<?php

ini_set('max_execution_time', 0); 
ini_set('memory_limit','2048M');

require(APPPATH.'/libraries/Rest.php');

class Service extends Rest
{
	function remove_nulls($data)
	{
		$resp = array();

		foreach($data as $key => $value)
		{
			if (is_object($value) || is_array($value))
			{
				$resp[$key] = $this->remove_nulls((array)$value);				
			}
			else
			{
				if ($value !== null)
				{
					$resp[$key] = $value;
				}
			}
		}

		return $resp;
	}		

	public function getUsuario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/UsuarioBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('UsuarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oUsuarioBE = new UsuarioBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oUsuarioBE->idUsuario = $this->post('idUsuario');
					$oUsuarioBE->login = $this->post('login');
					$oUsuarioBE->clave = $this->post('clave');
				
					$list = $this->UsuarioDAO->getUsuario($oUsuarioBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->listUsuario = $list;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getUsuario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getUsuario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setUsuario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/UsuarioBE');		
		$this->load->library('entities/ResponseBE');		

		$this->load->model('UsuarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oUsuarioBE = new UsuarioBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oUsuarioBE->idUsuario = $this->post('idUsuario');
					$oUsuarioBE->idPerfil = $this->post('idPerfil');
					$oUsuarioBE->idSexo = $this->post('idSexo');
					$oUsuarioBE->nombres = $this->post('nombres');
					$oUsuarioBE->apellidos = $this->post('apellidos');
					$oUsuarioBE->telefono = $this->post('telefono');
					$oUsuarioBE->email = $this->post('email');
					$oUsuarioBE->login = $this->post('login');
					$oUsuarioBE->clave = $this->post('clave');
					$oUsuarioBE->fotoBase64 = $this->post('fotoBase64');					
					$oUsuarioBE->observacion = $this->post('observacion');
					$oUsuarioBE->idUsuCrea = $this->post('idUsuCrea');
					$oUsuarioBE->idUsuMod = $this->post('idUsuMod');
					$oUsuarioBE->eliminado = $this->post('eliminado');

					if ($oUsuarioBE->idUsuario == 0)
					{
						$oUsuarioBEResp = $this->UsuarioDAO->createUsuario($oUsuarioBE, $retorno, $mensaje);
					}
					else
					{
						$oUsuarioBEResp = $this->UsuarioDAO->updateUsuario($oUsuarioBE, $retorno, $mensaje);
					}					
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "setUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->usuario = $oUsuarioBEResp;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "setUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "setUsuario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "setUsuario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delUsuario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/UsuarioBE');		
		$this->load->library('entities/ResponseBE');		

		$this->load->model('UsuarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oUsuarioBE = new UsuarioBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oUsuarioBE->idUsuario = $this->post('idUsuario');
					$oUsuarioBE->idUsuMod = $this->post('idUsuMod');

					$oUsuarioBEResp = $this->UsuarioDAO->deleteUsuario($oUsuarioBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;						
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "delUsuario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delUsuario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function autenticarUsuario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/UsuarioBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('UsuarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oUsuarioBE = new UsuarioBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$obj = null;

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {		    						
					$oUsuarioBE->login = $this->post('login');
					$oUsuarioBE->clave = $this->post('clave');

					$obj = $this->UsuarioDAO->authenticateUsuario($oUsuarioBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "autenticarUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->usuario = $obj;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "autenticarUsuario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "authenticateUsuario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "authenticateUsuario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}	

	public function getPerfil_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/PerfilBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('PerfilDAO');
									
		$oMensajeBE = new MensajeBE();
		$oPerfilBE = new PerfilBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oPerfilBE->idPerfil = $this->post('idPerfil');
					$oPerfilBE->nombre = $this->post('nombre');
				
					$list = $this->PerfilDAO->getPerfil($oPerfilBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getPerfil";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->listPerfil = $list;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getPerfil";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getPerfil";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getPerfil";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setPerfil_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/PerfilBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('PerfilDAO');
									
		$oMensajeBE = new MensajeBE();
		$oPerfilBE = new PerfilBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oPerfilBE->idPerfil = $this->post('idPerfil');
					$oPerfilBE->nombre = $this->post('nombre');
					$oPerfilBE->observacion = $this->post('observacion');
					$oPerfilBE->idUsuCrea = $this->post('idUsuCrea');
					$oPerfilBE->idUsuMod = $this->post('idUsuMod');					
				
					if ($oPerfilBE->idPerfil == 0)
					{
						$oPerfilBEResp = $this->PerfilDAO->createPerfil($oPerfilBE, $retorno, $mensaje);
					}
					else
					{
						$oPerfilBEResp = $this->PerfilDAO->updatePerfil($oPerfilBE, $retorno, $mensaje);
					}
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getPerfil";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->perfil = $oPerfilBEResp;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getPerfil";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getPerfil";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getPerfil";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delPerfil_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/PerfilBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('PerfilDAO');
									
		$oMensajeBE = new MensajeBE();
		$oPerfilBE = new PerfilBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oPerfilBE->idPerfil = $this->post('idPerfil');
					$oPerfilBE->idUsuMod = $this->post('idUsuMod');
				
					$oPerfilBEResp = $this->PerfilDAO->deletePerfil($oPerfilBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delPerfil";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;						
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delPerfil";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "delPerfil";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delPerfil";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getParametro_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ParametroBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ParametroDAO');
									
		$oMensajeBE = new MensajeBE();
		$oParametroBE = new ParametroBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oParametroBE->idParam = $this->post('idParam');
				$oParametroBE->tipParam = $this->post('tipParam');
				$oParametroBE->codigo = $this->post('codigo');
				$oParametroBE->codPadre = $this->post('codPadre');
				$oParametroBE->descripcion = $this->post('descripcion');
			
				$list = $this->ParametroDAO->getParametro($oParametroBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getParametro";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->listParametro = $list;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getParametro";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getParametro";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getParametro";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setParametro_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ParametroBE');		
		$this->load->library('entities/ResponseBE');		

		$this->load->model('ParametroDAO');
									
		$oMensajeBE = new MensajeBE();
		$oParametroBE = new ParametroBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oParametroBE->idParam = $this->post('idParam');
					$oParametroBE->tipParam = $this->post('tipParam');
					$oParametroBE->codigo = $this->post('codigo');
					$oParametroBE->codPadre = $this->post('codPadre');
					$oParametroBE->descripcion = $this->post('descripcion');
					$oParametroBE->abreviatura = $this->post('abreviatura');
					$oParametroBE->observacion = $this->post('observacion');
					$oParametroBE->idUsuCrea = $this->post('idUsuCrea');
					$oParametroBE->idUsuMod = $this->post('idUsuMod');

					if ($oParametroBE->idParam == 0)
					{
						$oParametroBEResp = $this->ParametroDAO->createParametro($oParametroBE, $retorno, $mensaje);
					}
					else
					{
						$oParametroBEResp = $this->ParametroDAO->updateParametro($oParametroBE, $retorno, $mensaje);
					}					
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "setParametro";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->parametro = $oParametroBEResp;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "setParametro";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "setParametro";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "setParametro";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delParametro_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ParametroBE');		
		$this->load->library('entities/ResponseBE');		

		$this->load->model('ParametroDAO');
									
		$oMensajeBE = new MensajeBE();
		$oParametroBE = new ParametroBE();
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oParametroBE->idParam = $this->post('idParam');					
					$oParametroBE->idUsuMod = $this->post('idUsuMod');					

					$oParametroBEResp = $this->ParametroDAO->deleteParametro($oParametroBE, $retorno, $mensaje);				
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delParametro";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->Parametro = $oParametroBEResp;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delParametro";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "delParametro";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delParametro";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getProveedor_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ProveedorBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('ProveedorDAO');
									
		$oMensajeBE = new MensajeBE();
		$oProveedorBE = new ProveedorBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oProveedorBE->idProveedor = $this->post('idProveedor');
				$oProveedorBE->idTipo = $this->post('idTipo');
				$oProveedorBE->idTipDoc = $this->post('idTipDoc');
				$oProveedorBE->numDoc = $this->post('numDoc');
				$oProveedorBE->nombres = $this->post('nombres');
				$oProveedorBE->apellidos = $this->post('apellidos');
				$oProveedorBE->razonSocial = $this->post('razonSocial');
			
				$list = $this->ProveedorDAO->getProveedor($oProveedorBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProveedor";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->listProveedor = $list;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProveedor";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getProveedor";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getProveedor";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setProveedor_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ProveedorBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ProveedorDAO');
									
		$oMensajeBE = new MensajeBE();
		$oProveedorBE = new ProveedorBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oProveedorBE->idProveedor = $this->post('idProveedor');
				$oProveedorBE->idTipo = $this->post('idTipo');
				$oProveedorBE->idTipDoc = $this->post('idTipDoc');
				$oProveedorBE->numDoc = $this->post('numDoc');
				$oProveedorBE->nombres = $this->post('nombres');
				$oProveedorBE->apellidos = $this->post('apellidos');
				$oProveedorBE->razonSocial = $this->post('razonSocial');
				$oProveedorBE->telefono = $this->post('telefono');
				$oProveedorBE->email = $this->post('email');
				$oProveedorBE->direccion = $this->post('direccion');
				$oProveedorBE->idUsuCrea = $this->post('idUsuCrea');
				$oProveedorBE->idUsuMod = $this->post('idUsuMod');
			
				if ($oProveedorBE->idProveedor == 0)
				{
					$oProveedorBEResp = $this->ProveedorDAO->createProveedor($oProveedorBE, $retorno, $mensaje);
				}
				else
				{
					$oProveedorBEResp = $this->ProveedorDAO->updateProveedor($oProveedorBE, $retorno, $mensaje);
				}
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProveedor";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->proveedor = $oProveedorBEResp;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProveedor";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getProveedor";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getProveedor";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delProveedor_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ProveedorBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ProveedorDAO');
									
		$oMensajeBE = new MensajeBE();
		$oProveedorBE = new ProveedorBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oProveedorBE->idProveedor = $this->post('idProveedor');
				$oProveedorBE->idUsuMod = $this->post('idUsuMod');
			
				$oProveedorBEResp = $this->ProveedorDAO->deleteProveedor($oProveedorBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delProveedor";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;						
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delProveedor";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "delProveedor";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delProveedor";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getCliente_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ClienteBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('ClienteDAO');
									
		$oMensajeBE = new MensajeBE();
		$oClienteBE = new ClienteBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oClienteBE->idCliente = $this->post('idCliente');
				$oClienteBE->idTipo = $this->post('idTipo');
				$oClienteBE->idTipDoc = $this->post('idTipDoc');
				$oClienteBE->numDoc = $this->post('numDoc');
				$oClienteBE->nombres = $this->post('nombres');
				$oClienteBE->apellidos = $this->post('apellidos');
				$oClienteBE->razonSocial = $this->post('razonSocial');
			
				$list = $this->ClienteDAO->getCliente($oClienteBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getCliente";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->listCliente = $list;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getCliente";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getCliente";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getCliente";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setCliente_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ClienteBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ClienteDAO');
									
		$oMensajeBE = new MensajeBE();
		$oClienteBE = new ClienteBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oClienteBE->idCliente = $this->post('idCliente');
				$oClienteBE->idTipo = $this->post('idTipo');
				$oClienteBE->idTipDoc = $this->post('idTipDoc');
				$oClienteBE->numDoc = $this->post('numDoc');
				$oClienteBE->nombres = $this->post('nombres');
				$oClienteBE->apellidos = $this->post('apellidos');
				$oClienteBE->razonSocial = $this->post('razonSocial');
				$oClienteBE->telefono = $this->post('telefono');
				$oClienteBE->email = $this->post('email');
				$oClienteBE->direccion = $this->post('direccion');
				$oClienteBE->idUsuCrea = $this->post('idUsuCrea');
				$oClienteBE->idUsuMod = $this->post('idUsuMod');
			
				if ($oClienteBE->idCliente == 0)
				{
					$oClienteBEResp = $this->ClienteDAO->createCliente($oClienteBE, $retorno, $mensaje);
				}
				else
				{
					$oClienteBEResp = $this->ClienteDAO->updateCliente($oClienteBE, $retorno, $mensaje);
				}
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getCliente";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->cliente = $oClienteBEResp;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getCliente";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getCliente";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getCliente";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delCliente_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ClienteBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ClienteDAO');
									
		$oMensajeBE = new MensajeBE();
		$oClienteBE = new ClienteBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oClienteBE->idCliente = $this->post('idCliente');
				$oClienteBE->idUsuMod = $this->post('idUsuMod');
			
				$oClienteBEResp = $this->ClienteDAO->deleteCliente($oClienteBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delCliente";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;						
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delCliente";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "delCliente";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delCliente";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getMaterial_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/MaterialBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('MaterialDAO');
									
		$oMensajeBE = new MensajeBE();
		$oMaterialBE = new MaterialBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oMaterialBE->idMaterial = $this->post('idMaterial');
					$oMaterialBE->descripcion = $this->post('descripcion');
				
					$list = $this->MaterialDAO->getMaterial($oMaterialBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getMaterial";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->listMaterial = $list;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getMaterial";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getMaterial";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getMaterial";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setMaterial_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/MaterialBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('MaterialDAO');
									
		$oMensajeBE = new MensajeBE();
		$oMaterialBE = new MaterialBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oMaterialBE->idMaterial = $this->post('idMaterial');
					$oMaterialBE->idUnidad = $this->post('idUnidad');
					$oMaterialBE->descripcion = $this->post('descripcion');
					$oMaterialBE->observacion = $this->post('observacion');
					$oMaterialBE->precio = $this->post('precio');
					$oMaterialBE->idUsuCrea = $this->post('idUsuCrea');					
					$oMaterialBE->idUsuMod = $this->post('idUsuMod');				
				
					if ($oMaterialBE->idMaterial == 0)
					{
						$oMaterialBEResp = $this->MaterialDAO->createMaterial($oMaterialBE, $retorno, $mensaje);
					}
					else
					{
						$oMaterialBEResp = $this->MaterialDAO->updateMaterial($oMaterialBE, $retorno, $mensaje);
					}
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getMaterial";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->material = $oMaterialBEResp;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getMaterial";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getMaterial";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getMaterial";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delMaterial_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/MaterialBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('MaterialDAO');
									
		$oMensajeBE = new MensajeBE();
		$oMaterialBE = new MaterialBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oMaterialBE->idMaterial = $this->post('idMaterial');
					$oMaterialBE->idUsuMod = $this->post('idUsuMod');					
				
					$oMaterialBEResp = $this->MaterialDAO->deleteMaterial($oMaterialBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delMaterial";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;						
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delMaterial";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "delMaterial";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delMaterial";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getOperario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/OperarioBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('OperarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oOperarioBE = new OperarioBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oOperarioBE->idOperario = $this->post('idOperario');
					$oOperarioBE->idTipDoc = $this->post('idTipDoc');
					$oOperarioBE->numDoc = $this->post('numDoc');
					$oOperarioBE->nombres = $this->post('nombres');
					$oOperarioBE->apellidos = $this->post('apellidos');				
				
					$list = $this->OperarioDAO->getOperario($oOperarioBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getOperario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->listOperario = $list;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getOperario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getOperario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getOperario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setOperario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/OperarioBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('OperarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oOperarioBE = new OperarioBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oOperarioBE->idOperario = $this->post('idOperario');
					$oOperarioBE->idTipDoc = $this->post('idTipDoc');
					$oOperarioBE->numDoc = $this->post('numDoc');
					$oOperarioBE->nombres = $this->post('nombres');
					$oOperarioBE->apellidos = $this->post('apellidos');
					$oOperarioBE->especialidad = $this->post('especialidad');
					$oOperarioBE->telefono = $this->post('telefono');
					$oOperarioBE->email = $this->post('email');
					$oOperarioBE->direccion = $this->post('direccion');
					$oOperarioBE->sctr = $this->post('sctr');
					$oOperarioBE->fecNacimiento = $this->post('fecNacimiento');
					$oOperarioBE->costo = $this->post('costo');
					$oOperarioBE->idUsuCrea = $this->post('idUsuCrea');					
					$oOperarioBE->idUsuMod = $this->post('idUsuMod');				
				
					if ($oOperarioBE->idOperario == 0)
					{
						$oOperarioBEResp = $this->OperarioDAO->createOperario($oOperarioBE, $retorno, $mensaje);
					}
					else
					{
						$oOperarioBEResp = $this->OperarioDAO->updateOperario($oOperarioBE, $retorno, $mensaje);
					}
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getOperario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->operario = $oOperarioBEResp;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getOperario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getOperario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getOperario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delOperario_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/OperarioBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('OperarioDAO');
									
		$oMensajeBE = new MensajeBE();
		$oOperarioBE = new OperarioBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oOperarioBE->idOperario = $this->post('idOperario');
					$oOperarioBE->idUsuMod = $this->post('idUsuMod');					
				
					$oOperarioBEResp = $this->OperarioDAO->deleteOperario($oOperarioBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delOperario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;						
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delOperario";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "delOperario";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delOperario";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getCotizacion_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/CotizacionBE');			
		$this->load->library('entities/CotiCostoBE');
		$this->load->library('entities/CotiMaterialBE');
		$this->load->library('entities/CotiOperarioBE');
		$this->load->library('entities/CotiMovilizacionBE');
		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');

		$this->load->model('CotizacionDAO');
									
		$oMensajeBE = new MensajeBE();
		$oCotizacionBE = new CotizacionBE();
		$oCotiMaterialBE = new CotiMaterialBE();
		$oCotiOperarioBE = new CotiOperarioBE();
		$oCotiMovilizacionBE = new CotiMovilizacionBE();
		$oCotiCostoBE = new CotiCostoBE();

		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oCotizacionBE->idCotizacion = $this->post('idCotizacion');
					$oCotizacionBE->idProveedor = $this->post('idProveedor');
					$oCotizacionBE->idCliente = $this->post('idCliente');
					$oCotizacionBE->idTipProy = $this->post('idTipProy');					
					$oCotizacionBE->numero = $this->post('numero');
					$oCotizacionBE->nomProy = $this->post('nomProy');
					$oCotizacionBE->orden = $this->post('orden');				
				
					$list = $this->CotizacionDAO->getCotizacion($oCotizacionBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getCotizacion";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->listCotizacion = $list;
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getCotizacion";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "getCotizacion";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getCotizacion";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setCotizacion_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/CotizacionBE');			
		$this->load->library('entities/CotiCostoBE');
		$this->load->library('entities/CotiMaterialBE');
		$this->load->library('entities/CotiOperarioBE');
		$this->load->library('entities/CotiMovilizacionBE');

		$this->load->library('entities/ProyectoBE');			
		$this->load->library('entities/ProyCostoBE');
		$this->load->library('entities/ProyMaterialBE');
		$this->load->library('entities/ProyOperarioBE');
		$this->load->library('entities/ProyMovilizacionBE');

		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');

		$this->load->model('CotizacionDAO');
		$this->load->model('ProyectoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oCotizacionBE = new CotizacionBE();
		$oCotiMaterialBE = new CotiMaterialBE();
		$oCotiOperarioBE = new CotiOperarioBE();
		$oCotiMovilizacionBE = new CotiMovilizacionBE();
		$oCotiCostoBE = new CotiCostoBE();

		$oProyectoBE = new ProyectoBE();
		$oProyMaterialBE = new ProyMaterialBE();
		$oProyOperarioBE = new ProyOperarioBE();
		$oProyMovilizacionBE = new ProyMovilizacionBE();
		$oProyCostoBE = new ProyCostoBE();

		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oCotizacionBE->idCotizacion = $this->post('idCotizacion');
				$oCotizacionBE->idProveedor = $this->post('idProveedor');
				$oCotizacionBE->idCliente = $this->post('idCliente');
				$oCotizacionBE->idTipProy = $this->post('idTipProy');
				$oCotizacionBE->idMoneda = $this->post('idMoneda');
				$oCotizacionBE->idEstado = $this->post('idEstado');
				$oCotizacionBE->numero = $this->post('numero');
				$oCotizacionBE->nomProy = $this->post('nomProy');
				$oCotizacionBE->orden = $this->post('orden');
				$oCotizacionBE->responsable = $this->post('responsable');
				$oCotizacionBE->fecCotizacion = $this->post('fecCotizacion');
				$oCotizacionBE->fecEmision = $this->post('fecEmision');
				$oCotizacionBE->fecInicio = $this->post('fecInicio');
				$oCotizacionBE->fecFin = $this->post('fecFin');
				$oCotizacionBE->valOferta = $this->post('valOferta');
				$oCotizacionBE->glosa = $this->post('glosa');
				$oCotizacionBE->subTotal = $this->post('subTotal');
				$oCotizacionBE->igv = $this->post('igv');
				$oCotizacionBE->descuento = $this->post('descuento');
				$oCotizacionBE->total = $this->post('total');
				$oCotizacionBE->idUsuCrea = $this->post('idUsuCrea');
				$oCotizacionBE->idUsuMod = $this->post('idUsuMod');
				$oCotizacionBE->listCotiMaterial = $this->post('listCotiMaterial');
				$oCotizacionBE->listCotiOperario = $this->post('listCotiOperario');
				$oCotizacionBE->listCotiMovilizacion = $this->post('listCotiMovilizacion');
				$oCotizacionBE->listCotiCosto = $this->post('listCotiCosto');
			
				if ($oCotizacionBE->idCotizacion == 0)
				{
					$oCotizacionBEResp = $this->CotizacionDAO->createCotizacion($oCotizacionBE, $retorno, $mensaje);						
				}
				else
				{
					$oCotizacionBEResp = $this->CotizacionDAO->updateCotizacion($oCotizacionBE, $retorno, $mensaje);
				}
				
				if ($retorno == 0)
				{
					if ($oCotizacionBE->idEstado == '00002')
					{						
						$oProyectoBE->idCotizacion = $oCotizacionBEResp->idCotizacion;
						$oProyectoBE->idProveedor = $this->post('idProveedor');
						$oProyectoBE->idCliente = $this->post('idCliente');
						$oProyectoBE->idTipProy = $this->post('idTipProy');
						$oProyectoBE->idMoneda = $this->post('idMoneda');
						$oProyectoBE->idEstado = $this->post('idEstado');
						$oProyectoBE->numero = $this->post('numero');
						$oProyectoBE->nomProy = $this->post('nomProy');
						$oProyectoBE->orden = $this->post('orden');
						$oProyectoBE->responsable = $this->post('responsable');
						$oProyectoBE->fecCotizacion = $this->post('fecCotizacion');
						$oProyectoBE->fecEmision = $this->post('fecEmision');
						$oProyectoBE->fecInicio = $this->post('fecInicio');
						$oProyectoBE->fecFin = $this->post('fecFin');
						$oProyectoBE->valOferta = $this->post('valOferta');
						$oProyectoBE->glosa = $this->post('glosa');
						$oProyectoBE->subTotal = $this->post('subTotal');
						$oProyectoBE->igv = $this->post('igv');
						$oProyectoBE->descuento = $this->post('descuento');
						$oProyectoBE->total = $this->post('total');
						$oProyectoBE->idUsuCrea = $this->post('idUsuMod');						
						$oProyectoBE->listProyMaterial = $this->post('listCotiMaterial');
						$oProyectoBE->listProyOperario = $this->post('listCotiOperario');
						$oProyectoBE->listProyMovilizacion = $this->post('listCotiMovilizacion');
						$oProyectoBE->listProyCosto = $this->post('listCotiCosto');
						
						$oProyectoBEResp = $this->ProyectoDAO->createProyecto($oProyectoBE, $retorno, $mensaje);							
						
						if ($retorno == 0)
						{
							$oMensajeBE->codigo = $retorno;
							$oMensajeBE->origen = "getCotizacion";
							$oMensajeBE->descripcion = "Cotizacion grabada correctamente";
							$oMensajeBE->tipo = "OK";					

							$oResponseBE->mensaje = $oMensajeBE;
							$oResponseBE->cotizacion = $oCotizacionBEResp;
						}
						else
						{
							$oMensajeBE->codigo = $retorno;
							$oMensajeBE->origen = "getCotizacion";
							$oMensajeBE->descripcion = $mensaje;
							$oMensajeBE->tipo = "ERROR";

							$oResponseBE->mensaje = $oMensajeBE;
						}
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "getCotizacion";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->cotizacion = $oCotizacionBEResp;
					}						
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getCotizacion";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getCotizacion";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getCotizacion";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delCotizacion_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/CotizacionBE');			
		$this->load->library('entities/CotiCostoBE');
		$this->load->library('entities/CotiMaterialBE');
		$this->load->library('entities/CotiOperarioBE');
		$this->load->library('entities/CotiMovilizacionBE');
		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');

		$this->load->model('CotizacionDAO');
									
		$oMensajeBE = new MensajeBE();
		$oCotizacionBE = new CotizacionBE();
		$oCotiMaterialBE = new CotiMaterialBE();
		$oCotiOperarioBE = new CotiOperarioBE();
		$oCotiMovilizacionBE = new CotiMovilizacionBE();
		$oCotiCostoBE = new CotiCostoBE();

		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
					$oCotizacionBE->idCotizacion = $this->post('idCotizacion');
					$oCotizacionBE->idUsuMod = $this->post('idUsuMod');
				
					$oCotizacionBEResp = $this->CotizacionDAO->deleteCotizacion($oCotizacionBE, $retorno, $mensaje);
					
					if ($retorno == 0)
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delCotizacion";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "OK";					

						$oResponseBE->mensaje = $oMensajeBE;						
					}
					else
					{
						$oMensajeBE->codigo = $retorno;
						$oMensajeBE->origen = "delCotizacion";
						$oMensajeBE->descripcion = $mensaje;
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;					
					}
				}
				else
				{				
					$oMensajeBE->codigo = 1;
					$oMensajeBE->descripcion = 'Key Incorrecta';
					$oMensajeBE->origen = "delCotizacion";
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;							
				}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delCotizacion";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getCotizacionPDF_post()
	{				
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/CotizacionBE');
		$this->load->library('entities/CotiCostoBE');
		$this->load->library('entities/CotiMaterialBE');
		$this->load->library('entities/CotiOperarioBE');
		$this->load->library('entities/CotiMovilizacionBE');
		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ParametroBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');		
		$this->load->library('Pdf');		

		$this->load->model('CotizacionDAO');
		$this->load->model('ParametroDAO');
									
		$oMensajeBE = new MensajeBE();
		$oParametroBE = new ParametroBE();
		$oCotizacionBE = new CotizacionBE();
		$oCotiMaterialBE = new CotiMaterialBE();
		$oCotiOperarioBE = new CotiOperarioBE();
		$oCotiMovilizacionBE = new CotiMovilizacionBE();
		$oCotiCostoBE = new CotiCostoBE();

		$oResponseBE = new ResponseBE();
		
		$Pdf = new Pdf();

		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oCotizacionBE->idCotizacion = $this->post('idCotizacion');
				$oCotizacionBE->flag1 = $this->post('flag1');
				$oCotizacionBE->flag2 = $this->post('flag2');
				$oCotizacionBE->flag3 = $this->post('flag3');
				$oCotizacionBE->flag4 = $this->post('flag4');

				$list = $this->CotizacionDAO->getCotizacion($oCotizacionBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					if (count($list))
					{
						$name = 'Cotizacion.pdf';

						$list[0]->flag1 = $oCotizacionBE->flag1;
						$list[0]->flag2 = $oCotizacionBE->flag2;
						$list[0]->flag3 = $oCotizacionBE->flag3;
						$list[0]->flag4 = $oCotizacionBE->flag4;

						$body = $this->load->view('Cotizacion.php',$list[0],TRUE);

						$Pdf->set_option('isHtml5ParserEnabled', true);
    					$Pdf->set_option('isRemoteEnabled', true);

						$Pdf->loadHtml($body);

						$Pdf->setPaper('A4', 'portrait');
						
						$Pdf->render();				

						$output = $Pdf->output();										
						
						file_put_contents(PATH_DOC_COTI.$name, $output);

						$oMensajeBE->codigo = 0;
						$oMensajeBE->origen = "getCotizacionPDF";
						$oMensajeBE->descripcion = 'Reporte generado correctamente';
						$oMensajeBE->tipo = "OK";

						$oResponseBE->mensaje = $oMensajeBE;
						$oResponseBE->url = RUTA_DOC_COTI.$name;
					}
					else
					{
						$oMensajeBE->codigo = 1;
						$oMensajeBE->origen = "getCotizacionPDF";
						$oMensajeBE->descripcion = 'La Cotizacion ingresada no existe';
						$oMensajeBE->tipo = "ERROR";

						$oResponseBE->mensaje = $oMensajeBE;
					}					
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getCotizacionPDF";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getCotizacionPDF";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getCotizacionPDF";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));		
	}

	public function getProyecto_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ProyectoBE');			
		$this->load->library('entities/ProyCostoBE');
		$this->load->library('entities/ProyMaterialBE');
		$this->load->library('entities/ProyOperarioBE');
		$this->load->library('entities/ProyMovilizacionBE');
		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');

		$this->load->model('ProyectoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oProyectoBE = new ProyectoBE();
		$oProyMaterialBE = new ProyMaterialBE();
		$oProyOperarioBE = new ProyOperarioBE();
		$oProyMovilizacionBE = new ProyMovilizacionBE();
		$oProyCostoBE = new ProyCostoBE();

		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oProyectoBE->idProyecto = $this->post('idProyecto');
				$oProyectoBE->idCotizacion = $this->post('idCotizacion');
				$oProyectoBE->idProveedor = $this->post('idProveedor');
				$oProyectoBE->idCliente = $this->post('idCliente');
				$oProyectoBE->idTipProy = $this->post('idTipProy');					
				$oProyectoBE->numero = $this->post('numero');
				$oProyectoBE->nomProy = $this->post('nomProy');
				$oProyectoBE->orden = $this->post('orden');				
			
				$list = $this->ProyectoDAO->getProyecto($oProyectoBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProyecto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->listProyecto = $list;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProyecto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getProyecto";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getProyecto";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setProyecto_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ProyectoBE');			
		$this->load->library('entities/ProyCostoBE');
		$this->load->library('entities/ProyMaterialBE');
		$this->load->library('entities/ProyOperarioBE');
		$this->load->library('entities/ProyMovilizacionBE');
		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');

		$this->load->model('ProyectoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oProyectoBE = new ProyectoBE();
		$oProyMaterialBE = new ProyMaterialBE();
		$oProyOperarioBE = new ProyOperarioBE();
		$oProyMovilizacionBE = new ProyMovilizacionBE();
		$oProyCostoBE = new ProyCostoBE();

		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oProyectoBE->idProyecto = $this->post('idProyecto');
				$oProyectoBE->idCotizacion = $this->post('idCotizacion');
				$oProyectoBE->idProveedor = $this->post('idProveedor');
				$oProyectoBE->idCliente = $this->post('idCliente');
				$oProyectoBE->idTipProy = $this->post('idTipProy');
				$oProyectoBE->idMoneda = $this->post('idMoneda');
				$oProyectoBE->idEstado = $this->post('idEstado');
				$oProyectoBE->numero = $this->post('numero');
				$oProyectoBE->nomProy = $this->post('nomProy');
				$oProyectoBE->orden = $this->post('orden');
				$oProyectoBE->responsable = $this->post('responsable');
				$oProyectoBE->fecCotizacion = $this->post('fecCotizacion');
				$oProyectoBE->fecEmision = $this->post('fecEmision');
				$oProyectoBE->fecInicio = $this->post('fecInicio');
				$oProyectoBE->fecFin = $this->post('fecFin');
				$oProyectoBE->valOferta = $this->post('valOferta');
				$oProyectoBE->glosa = $this->post('glosa');
				$oProyectoBE->subTotal = $this->post('subTotal');
				$oProyectoBE->igv = $this->post('igv');
				$oProyectoBE->descuento = $this->post('descuento');
				$oProyectoBE->total = $this->post('total');
				$oProyectoBE->idUsuCrea = $this->post('idUsuCrea');
				$oProyectoBE->idUsuMod = $this->post('idUsuMod');
				$oProyectoBE->listProyMaterial = $this->post('listProyMaterial');
				$oProyectoBE->listProyOperario = $this->post('listProyOperario');
				$oProyectoBE->listProyMovilizacion = $this->post('listProyMovilizacion');
				$oProyectoBE->listProyCosto = $this->post('listProyCosto');
			
				if ($oProyectoBE->idProyecto == 0)
				{
					$oProyectoBEResp = $this->ProyectoDAO->createProyecto($oProyectoBE, $retorno, $mensaje);
				}
				else
				{
					$oProyectoBEResp = $this->ProyectoDAO->updateProyecto($oProyectoBE, $retorno, $mensaje);
				}
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProyecto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->proyecto = $oProyectoBEResp;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getProyecto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getProyecto";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getProyecto";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delProyecto_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ProyectoBE');			
		$this->load->library('entities/ProyCostoBE');
		$this->load->library('entities/ProyMaterialBE');
		$this->load->library('entities/ProyOperarioBE');
		$this->load->library('entities/ProyMovilizacionBE');
		$this->load->library('entities/ProveedorBE');
		$this->load->library('entities/ClienteBE');
		$this->load->library('entities/ResponseBE');

		$this->load->model('ProyectoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oProyectoBE = new ProyectoBE();
		$oProyMaterialBE = new ProyMaterialBE();
		$oProyOperarioBE = new ProyOperarioBE();
		$oProyMovilizacionBE = new ProyMovilizacionBE();
		$oProyCostoBE = new ProyCostoBE();

		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oProyectoBE->idProyecto = $this->post('idProyecto');
				$oProyectoBE->idUsuMod = $this->post('idUsuMod');
			
				$oProyectoBEResp = $this->ProyectoDAO->deleteProyecto($oProyectoBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delProyecto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;						
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delProyecto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "delProyecto";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delProyecto";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getConcepto_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ConceptoBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('ConceptoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oConceptoBE = new ConceptoBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oConceptoBE->idConcepto = $this->post('idConcepto');
				$oConceptoBE->idTipo = $this->post('idTipo');
			
				$list = $this->ConceptoDAO->getConcepto($oConceptoBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getConcepto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->listConcepto = $list;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getConcepto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getConcepto";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getConcepto";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function setConcepto_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ConceptoBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ConceptoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oConceptoBE = new ConceptoBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oConceptoBE->idConcepto = $this->post('idConcepto');
				$oConceptoBE->idTipo = $this->post('idTipo');
				$oConceptoBE->fecha = $this->post('fecha');
				$oConceptoBE->empresa = $this->post('empresa');
				$oConceptoBE->descripcion = $this->post('descripcion');
				$oConceptoBE->responsable = $this->post('responsable');
				$oConceptoBE->monto = $this->post('monto');
				$oConceptoBE->idUsuCrea = $this->post('idUsuCrea');				
				$oConceptoBE->idUsuMod = $this->post('idUsuMod');		
			
				if ($oConceptoBE->idConcepto == 0)
				{
					$oConceptoBEResp = $this->ConceptoDAO->createConcepto($oConceptoBE, $retorno, $mensaje);
				}
				else
				{
					$oConceptoBEResp = $this->ConceptoDAO->updateConcepto($oConceptoBE, $retorno, $mensaje);
				}
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getConcepto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->concepto = $oConceptoBEResp;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getConcepto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getConcepto";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getConcepto";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function delConcepto_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ConceptoBE');		
		$this->load->library('entities/ResponseBE');

		$this->load->model('ConceptoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oConceptoBE = new ConceptoBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {
				$oConceptoBE->idConcepto = $this->post('idConcepto');
				$oConceptoBE->idUsuMod = $this->post('idUsuMod');					
			
				$oConceptoBEResp = $this->ConceptoDAO->deleteConcepto($oConceptoBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delConcepto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";					

					$oResponseBE->mensaje = $oMensajeBE;						
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "delConcepto";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "delConcepto";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "delConcepto";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}

	public function getConceptoResumen_post()
	{
		header('Content-Type: application/json', true);
		
		$this->load->library('entities/MensajeBE');		
		$this->load->library('entities/ConceptoBE');			
		$this->load->library('entities/ResponseBE');

		$this->load->model('ConceptoDAO');
									
		$oMensajeBE = new MensajeBE();
		$oConceptoBE = new ConceptoBE();		
		$oResponseBE = new ResponseBE();
		
		$retorno = 0;
		$mensaje = "";

		$list = array();

		try 
		{			
		    $key = $_SERVER['HTTP_KEYID'];
		 
		    if ($key == KEY_SECURITY)
		    {							
				$list = $this->ConceptoDAO->getConceptoResumen($oConceptoBE, $retorno, $mensaje);
				
				if ($retorno == 0)
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getConceptoResumen";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "OK";

					$oResponseBE->mensaje = $oMensajeBE;
					$oResponseBE->listConcepto = $list;
				}
				else
				{
					$oMensajeBE->codigo = $retorno;
					$oMensajeBE->origen = "getConceptoResumen";
					$oMensajeBE->descripcion = $mensaje;
					$oMensajeBE->tipo = "ERROR";

					$oResponseBE->mensaje = $oMensajeBE;					
				}
			}
			else
			{				
				$oMensajeBE->codigo = 1;
				$oMensajeBE->descripcion = 'Key Incorrecta';
				$oMensajeBE->origen = "getConceptoResumen";
				$oMensajeBE->tipo = "ERROR";

				$oResponseBE->mensaje = $oMensajeBE;							
			}
		} 
		catch (Exception $e) 
		{			
			$oMensajeBE->codigo = 1;
			$oMensajeBE->descripcion = $e->getMessage();
			$oMensajeBE->origen = "getConceptoResumen";
			$oMensajeBE->tipo = "ERROR";

			$oResponseBE->mensaje = $oMensajeBE;			
		}

		echo json_encode($this->remove_nulls((array)$oResponseBE));
	}
}

?>