<?php

class ClienteDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getCliente($oClienteBE, &$retorno, &$mensaje)
    {
        $idCliente = $oClienteBE->idCliente;
        $idTipo = $oClienteBE->idTipo;
        $idTipDoc = $oClienteBE->idTipDoc;
        $numDoc = $oClienteBE->numDoc;
        $nombres = $oClienteBE->nombres;
        $apellidos = $oClienteBE->apellidos;
        $razonSocial = $oClienteBE->razonSocial;        

        $listResult = array();
              
        $sql = "SELECT
                    T1.idcliente,
                    T1.idtipo,
                    T1.idtipdoc,
                    T1.numdoc,
                    T1.nombres,
                    T1.apellidos,
                    T1.razonsocial,
                    T1.telefono,
                    T1.email,
                    T1.direccion,	
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_PERSONA' AND TT.codigo = T1.idtipo AND TT.eliminado = 0 LIMIT 1) AS dsctipo,
                    (SELECT TT.abreviatura FROM parametro TT WHERE TT.tipparam = 'TIPO_DOCUMENTO' AND TT.codigo = T1.idtipdoc AND TT.eliminado = 0 LIMIT 1) AS dsctipdoc,
                    (CASE T1.idtipo
                        WHEN '00001' THEN CONCAT(COALESCE(T1.nombres,''),' ',COALESCE(T1.apellidos,''))
                        WHEN '00002' THEN T1.razonsocial
                        ELSE ''
                    END) AS nomcompleto
                FROM
                    cliente T1
                WHERE
                    COALESCE(?,0) IN (T1.idcliente,0)
                    AND COALESCE(?,'') IN (T1.idtipo,'')
                    AND COALESCE(?,'') IN (T1.idtipdoc,'')
                    AND COALESCE(?,'') IN (T1.numdoc,'')
                    AND UPPER(COALESCE(T1.nombres,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND UPPER(COALESCE(T1.apellidos,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND UPPER(COALESCE(T1.razonsocial,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND T1.eliminado = 0
                ORDER BY
                    5";
        
        $query = $this->db->query($sql, array($idCliente,
                                              $idTipo,
                                              $idTipDoc,
                                              $numDoc,
                                              $nombres,
                                              $apellidos,
                                              $razonSocial));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oClienteBE = new ClienteBE();

            $oClienteBE->idCliente = (int)$row->idcliente;
            $oClienteBE->idTipo = $row->idtipo;
            $oClienteBE->idTipDoc = $row->idtipdoc;
            $oClienteBE->numDoc = $row->numdoc;
            $oClienteBE->nombres = $row->nombres;
            $oClienteBE->apellidos = $row->apellidos;
            $oClienteBE->razonSocial = $row->razonsocial;
            $oClienteBE->telefono = $row->telefono;
            $oClienteBE->email = $row->email;
            $oClienteBE->direccion = $row->direccion;            
            $oClienteBE->dscTipo = $row->dsctipo;
            $oClienteBE->dscTipDoc = $row->dsctipdoc;
            $oClienteBE->nomCompleto = $row->nomcompleto;

            array_push($listResult, $oClienteBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createCliente($oClienteBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                        
        $idTipo = $oClienteBE->idTipo;
        $idTipDoc = $oClienteBE->idTipDoc;
        $numDoc = $oClienteBE->numDoc;
        $nombres = $oClienteBE->nombres;
        $apellidos = $oClienteBE->apellidos;
        $razonSocial = $oClienteBE->razonSocial;
        $telefono = $oClienteBE->telefono;
        $email = $oClienteBE->email;
        $direccion = $oClienteBE->direccion;
        $idUsuCrea = $oClienteBE->idUsuCrea;

        $idCliente = $this->util->getNextId("cliente","idcliente");
                
        if ($idCliente > 0)
        {
            $sql = "INSERT INTO cliente
                    (
                        idcliente,
                        idtipo,
                        idtipdoc,
                        numdoc,
                        nombres,
                        apellidos,
                        razonsocial,
                        telefono,
                        email,
                        direccion,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idCliente,
                                                  $idTipo,
                                                  $idTipDoc,
                                                  $numDoc,
                                                  $nombres,
                                                  $apellidos,
                                                  $razonSocial,
                                                  $telefono,
                                                  $email,
                                                  $direccion,
                                                  $idUsuCrea));

            if($query)
            {
                $oClienteBE = new ClienteBE();

                $oClienteBE->idCliente = $idCliente;

                $listResult = $this->getCliente($oClienteBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Cliente grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Ocurrió un error al obtener el codigo de Cliente";
        }

        return $objResult;
    }

    public function updateCliente($oClienteBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idCliente = $oClienteBE->idCliente;
        $idTipo = $oClienteBE->idTipo;
        $idTipDoc = $oClienteBE->idTipDoc;
        $numDoc = $oClienteBE->numDoc;
        $nombres = $oClienteBE->nombres;
        $apellidos = $oClienteBE->apellidos;
        $razonSocial = $oClienteBE->razonSocial;
        $telefono = $oClienteBE->telefono;
        $email = $oClienteBE->email;
        $direccion = $oClienteBE->direccion;        
        $idUsuMod = $oClienteBE->idUsuMod;

        $idUsuMod = $oClienteBE->idUsuMod;
        
        if ($idCliente > 0)
        {
            $oClienteBE = new ClienteBE();

            $oClienteBE->idCliente = $idCliente;

            $listResult = $this->getCliente($oClienteBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {
                $sql = "UPDATE 
                            cliente
                        SET
                            idtipo = COALESCE(?,idtipo),
                            idtipdoc = COALESCE(?,idtipdoc),
                            numdoc = COALESCE(?,numdoc),
                            nombres = COALESCE(?,nombres),
                            apellidos = COALESCE(?,apellidos),
                            razonsocial = COALESCE(?,razonsocial),
                            telefono = COALESCE(?,telefono),
                            email = COALESCE(?,email),
                            direccion = COALESCE(?,direccion),	
                            idusumod = COALESCE(?,idusumod),
                            fecusumod = NOW()
                        WHERE
                            idcliente = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idTipo,
                                                      $idTipDoc,
                                                      $numDoc,
                                                      $nombres,
                                                      $apellidos,
                                                      $razonSocial,
                                                      $telefono,
                                                      $email,
                                                      $direccion,                
                                                      $idUsuMod,
                                                      $idCliente));

                if($query)
                {
                    $oClienteBE = new ClienteBE();

                    $oClienteBE->idCliente = $idCliente;

                    $listResult = $this->getCliente($oClienteBE, $retorno, $mensaje);

                    if(count($listResult) > 0)
                    {
                        $objResult = $listResult[0];

                        $retorno = 0;
                        $mensaje = "Cliente grabado correctamente";
                    }
                    else
                    {
                        $retorno = 1;
                        $mensaje = MSG_ERROR_GENERAL;
                    }
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Cliente no existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cliente";
        }

        return $objResult;
    }

    public function deleteCliente($oClienteBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idCliente = $oClienteBE->idCliente;        
        $idUsuMod = $oClienteBE->idUsuMod;
        
        if ($idCliente > 0)
        {
            $oClienteBE = new ClienteBE();

            $oClienteBE->idCliente = $idCliente;

            $listResult = $this->getCliente($oClienteBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {                
                $sql = "UPDATE 
                           cliente
                        SET
                           idusumod = ?,
                           fecusumod = NOW(),
                           eliminado = 1
                        WHERE
                           idcliente = ?
                           AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idUsuMod,
                                                      $idCliente));
                if($query)
                {
                    $retorno = 0;
                    $mensaje = "Cliente eliminado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Cliente no existe";
            }                    
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cliente";
        }

        return $objResult;
    }    
}
?>