<?php

class CotiCostoDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getCotiCosto($oCotiCostoBE, &$retorno, &$mensaje)
    {
        $idCotizacion = $oCotiCostoBE->idCotizacion;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idcotizacion,
                    T1.titulo,
                    T1.descripcion,
                    DATE_FORMAT(T1.fecha, '%d/%m/%Y') AS fecha,
                    T1.valor
                FROM
                    coticosto T1
                WHERE
                    COALESCE(?,0) IN (T1.idcotizacion,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,2";
        
        $query = $this->db->query($sql, array($idCotizacion));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oCotiCostoBE = new CotiCostoBE();

            $oCotiCostoBE->idCotizacion = (int)$row->idcotizacion;
            $oCotiCostoBE->titulo = $row->titulo;
            $oCotiCostoBE->descripcion = $row->descripcion;
            $oCotiCostoBE->fecha = $row->fecha;
            $oCotiCostoBE->valor = (double)$row->valor;

            array_push($listResult, $oCotiCostoBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createCotiCosto($oCotiCostoBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idCotizacion = $oCotiCostoBE->idCotizacion;
        $titulo = $oCotiCostoBE->titulo;
        $descripcion = $oCotiCostoBE->descripcion;
        $fecha = $oCotiCostoBE->fecha;
        $valor = $oCotiCostoBE->valor;
        $idUsuCrea = $oCotiCostoBE->idUsuCrea;
                
        if ($idCotizacion > 0)
        {
            $sql = "INSERT INTO coticosto
                    (
                        idcotizacion,
                        titulo,
                        descripcion,
                        fecha,
                        valor,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idCotizacion,
                                                  $titulo,
                                                  $descripcion,
                                                  $fecha,
                                                  $valor,
                                                  $idUsuCrea));

            if($query)
            {
                $oCotiCostoBE = new CotiCostoBE();

                $oCotiCostoBE->idCotizacion = $idCotizacion;                

                $listResult = $this->getCotiCosto($oCotiCostoBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Costo de cotizacion grabada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }

    public function deleteCotiCosto($oCotiCostoBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idCotizacion = $oCotiCostoBE->idCotizacion;                
        
        if ($idCotizacion > 0)
        {            
            $sql = "DELETE FROM coticosto WHERE idcotizacion=?";
                
            $query = $this->db->query($sql, array($idCotizacion));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Costos de Cotizacion eliminados correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }
}
?>