<?php

class CotiMaterialDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getCotiMaterial($oCotiMaterialBE, &$retorno, &$mensaje)
    {
        $idCotizacion = $oCotiMaterialBE->idCotizacion;
        $idMaterial = $oCotiMaterialBE->idMaterial;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idcotizacion,
                    T1.idmaterial,
                    T1.cantidad,
                    T1.precio,
                    (CASE
                        WHEN T3.idestado = '00001' THEN ROUND(T1.precio*(SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_CAMBIO' AND TT.codigo = '00001' AND TT.eliminado = 0 LIMIT 1),2) 
                        ELSE T1.preciosoles
                    END) AS preciosoles,
                    T1.total,
                    (CASE
                        WHEN T3.idestado = '00001' THEN ROUND(T1.cantidad*T1.precio*(SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_CAMBIO' AND TT.codigo = '00001' AND TT.eliminado = 0 LIMIT 1),2) 
                        ELSE T1.totalsoles
                    END) AS totalsoles,
                    T2.descripcion AS dscmaterial
                FROM
                    cotimaterial T1
                    INNER JOIN material T2 ON
                        T2.idmaterial = T1.idmaterial
                    INNER JOIN cotizacion T3 ON
                        T3.idcotizacion = T1.idcotizacion
                WHERE
                    COALESCE(?,0) IN (T1.idcotizacion,0)
                    AND COALESCE(?,0) IN (T1.idmaterial,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,6";
        
        $query = $this->db->query($sql, array($idCotizacion, $idMaterial));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oCotiMaterialBE = new CotiMaterialBE();

            $oCotiMaterialBE->idCotizacion = (int)$row->idcotizacion;
            $oCotiMaterialBE->idMaterial = (int)$row->idmaterial;
            $oCotiMaterialBE->cantidad = (double)$row->cantidad;
            $oCotiMaterialBE->precio = (double)$row->precio;
            $oCotiMaterialBE->precioSoles = (double)$row->preciosoles;
            $oCotiMaterialBE->total = (double)$row->total;
            $oCotiMaterialBE->totalSoles = (double)$row->totalsoles;
            $oCotiMaterialBE->dscMaterial = $row->dscmaterial;

            array_push($listResult, $oCotiMaterialBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createCotiMaterial($oCotiMaterialBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idCotizacion = $oCotiMaterialBE->idCotizacion;
        $idMaterial = $oCotiMaterialBE->idMaterial;
        $cantidad = $oCotiMaterialBE->cantidad;
        $precio = $oCotiMaterialBE->precio;
        $precioSoles = $oCotiMaterialBE->precioSoles;
        $total = $oCotiMaterialBE->total;
        $totalSoles = $oCotiMaterialBE->totalSoles;
        $idUsuCrea = $oCotiMaterialBE->idUsuCrea;
                
        if ($idCotizacion > 0 && $idMaterial > 0)
        {
            $sql = "INSERT INTO cotimaterial
                    (
                        idcotizacion,
                        idmaterial,
                        cantidad,
                        precio,
                        preciosoles,
                        total,
                        totalsoles,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    );";
                
            $query = $this->db->query($sql, array($idCotizacion,
                                                  $idMaterial,
                                                  $cantidad,
                                                  $precio,
                                                  $precioSoles,
                                                  $total,
                                                  $totalSoles,
                                                  $idUsuCrea));

            if($query)
            {
                $oCotiMaterialBE = new CotiMaterialBE();

                $oCotiMaterialBE->idCotizacion = $idCotizacion;
                $oCotiMaterialBE->idMaterial = $idMaterial;

                $listResult = $this->getCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Material de cotizacion grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion y el codigo de Material";
        }

        return $objResult;
    }    

    public function deleteCotiMaterial($oCotiMaterialBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idCotizacion = $oCotiMaterialBE->idCotizacion;                
        
        if ($idCotizacion > 0)
        {            
            $sql = "DELETE FROM cotimaterial WHERE idcotizacion=?";
                
            $query = $this->db->query($sql, array($idCotizacion));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Materiales de Cotizacion eliminados correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }
}
?>