<?php

class CotiMovilizacionDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getCotiMovilizacion($oCotiMovilizacionBE, &$retorno, &$mensaje)
    {
        $idCotizacion = $oCotiMovilizacionBE->idCotizacion;
        $semana = $oCotiMovilizacionBE->semana;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idcotizacion,
                    T1.semana,
                    T1.pasajes,
                    T1.alimentacion
                FROM
                    cotimovilizacion T1
                WHERE
                    COALESCE(?,0) IN (T1.idcotizacion,0)
                    AND COALESCE(?,0) IN (T1.semana,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,2";
        
        $query = $this->db->query($sql, array($idCotizacion,$semana));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oCotiMovilizacionBE = new CotiMovilizacionBE();

            $oCotiMovilizacionBE->idCotizacion = (int)$row->idcotizacion;
            $oCotiMovilizacionBE->semana = (int)$row->semana;
            $oCotiMovilizacionBE->pasajes = (double)$row->pasajes;
            $oCotiMovilizacionBE->alimentacion = (double)$row->alimentacion;

            array_push($listResult, $oCotiMovilizacionBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createCotiMovilizacion($oCotiMovilizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idCotizacion = $oCotiMovilizacionBE->idCotizacion;
        $semana = $oCotiMovilizacionBE->semana;
        $pasajes = $oCotiMovilizacionBE->pasajes;
        $alimentacion = $oCotiMovilizacionBE->alimentacion;
        $idUsuCrea = $oCotiMovilizacionBE->idUsuCrea;
                
        if ($idCotizacion > 0)
        {
            $sql = "INSERT INTO cotimovilizacion
                    (
                        idcotizacion,
                        semana,
                        pasajes,
                        alimentacion,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,	
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idCotizacion,
                                                  $semana,
                                                  $pasajes,
                                                  $alimentacion,
                                                  $idUsuCrea));

            if($query)
            {
                $oCotiMovilizacionBE = new CotiMovilizacionBE();

                $oCotiMovilizacionBE->idCotizacion = $idCotizacion;
                $oCotiMovilizacionBE->semana = $semana;

                $listResult = $this->getCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Movilizacion de cotizacion grabada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }    

    public function deleteCotiMovilizacion($oCotiMovilizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idCotizacion = $oCotiMovilizacionBE->idCotizacion;                
        
        if ($idCotizacion > 0)
        {            
            $sql = "DELETE FROM cotimovilizacion WHERE idcotizacion=?";
                
            $query = $this->db->query($sql, array($idCotizacion));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Movilizaciones de Cotizacion eliminadas correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }
}
?>