<?php

class CotiOperarioDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getCotiOperario($oCotiOperarioBE, &$retorno, &$mensaje)
    {
        $idCotizacion = $oCotiOperarioBE->idCotizacion;
        $idOperario = $oCotiOperarioBE->idOperario;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idcotizacion,
                    T1.idoperario,
                    DATE_FORMAT(T1.fecing, '%d/%m/%Y') AS fecing,
                    DATE_FORMAT(T1.fecegr, '%d/%m/%Y') AS fecegr,
                    T1.costo,
                    T1.total,
                    CONCAT(COALESCE(T2.nombres,''),' ',COALESCE(T2.apellidos,'')) AS nomoperario,
                    T2.numdoc AS numdocoperario,	
                    T2.especialidad AS especialidadoperario,
                    (SELECT TT.abreviatura FROM parametro TT WHERE TT.tipparam = 'TIPO_DOCUMENTO' AND TT.codigo = T2.idtipdoc AND TT.eliminado = 0 LIMIT 1) AS dsctipdocoperario
                FROM
                    cotioperario T1
                    INNER JOIN operario T2 ON
                        T2.idoperario = T1.idoperario
                WHERE
                    COALESCE(?,0) IN (T1.idcotizacion,0)
                    AND COALESCE(?,0) IN (T1.idoperario,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,6";
        
        $query = $this->db->query($sql, array($idCotizacion, $idOperario));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oCotiOperarioBE = new CotiOperarioBE();

            $oCotiOperarioBE->idCotizacion = (int)$row->idcotizacion;
            $oCotiOperarioBE->idOperario = (int)$row->idoperario;
            $oCotiOperarioBE->fecIng = $row->fecing;
            $oCotiOperarioBE->fecEgr = $row->fecegr;
            $oCotiOperarioBE->costo = (double)$row->costo;
            $oCotiOperarioBE->total = (double)$row->total;
            $oCotiOperarioBE->nomOperario = $row->nomoperario;
            $oCotiOperarioBE->numDocOperario = $row->numdocoperario;
            $oCotiOperarioBE->especialidadOperario = $row->especialidadoperario;
            $oCotiOperarioBE->dscTipDocOperario = $row->dsctipdocoperario;

            array_push($listResult, $oCotiOperarioBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createCotiOperario($oCotiOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idCotizacion = $oCotiOperarioBE->idCotizacion;
        $idOperario = $oCotiOperarioBE->idOperario;
        $fecIng = $oCotiOperarioBE->fecIng;
        $fecEgr = $oCotiOperarioBE->fecEgr;
        $costo = $oCotiOperarioBE->costo;
        $total = $oCotiOperarioBE->total;
        $idUsuCrea = $oCotiOperarioBE->idUsuCrea;
                
        if ($idCotizacion > 0 && $idOperario > 0)
        {
            $sql = "INSERT INTO cotioperario
                    (
                        idcotizacion,
                        idoperario,
                        fecing,
                        fecegr,
                        costo,
                        total,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,                        
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idCotizacion,
                                                  $idOperario,
                                                  $fecIng,
                                                  $fecEgr,
                                                  $costo,
                                                  $total,
                                                  $idUsuCrea));

            if($query)
            {
                $oCotiOperarioBE = new CotiOperarioBE();

                $oCotiOperarioBE->idCotizacion = $idCotizacion;
                $oCotiOperarioBE->idOperario = $idOperario;

                $listResult = $this->getCotiOperario($oCotiOperarioBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Operario de cotizacion grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion y el codigo de Operario";
        }

        return $objResult;
    }    

    public function deleteCotiOperario($oCotiOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idCotizacion = $oCotiOperarioBE->idCotizacion;                
        
        if ($idCotizacion > 0)
        {            
            $sql = "DELETE FROM cotioperario WHERE idcotizacion=?";
                
            $query = $this->db->query($sql, array($idCotizacion));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Operarios de Cotizacion eliminados correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }
}
?>