<?php

class CotizacionDAO extends CI_Model 
{
	public function __construct()
	{		 
		parent::__construct();
    }

    public function getCotizacion($oCotizacionBE, &$retorno, &$mensaje)
	{
        $this->load->model('CotiMaterialDAO', 'cotiMaterialDAO');
        $this->load->model('CotiOperarioDAO', 'cotiOperarioDAO');
        $this->load->model('CotiMovilizacionDAO', 'cotiMovilizacionDAO');
        $this->load->model('CotiCostoDAO', 'cotiCostoDAO');
        $this->load->model('ProveedorDAO', 'proveedorDAO');
        $this->load->model('ClienteDAO', 'clienteDAO');

        $idCotizacion = $oCotizacionBE->idCotizacion;
        $idProveedor = $oCotizacionBE->idProveedor;
        $idCliente = $oCotizacionBE->idCliente;
        $idTipProy = $oCotizacionBE->idTipProy;        
        $numero = $oCotizacionBE->numero;
        $nomProy = $oCotizacionBE->nomProy;
        $orden = $oCotizacionBE->orden;

		$listResult = array();
		
        $sql = "SELECT
                    T1.idcotizacion,
                    T1.idproveedor,
                    T1.idcliente,
                    T1.idtipproy,
                    T1.idmoneda,
                    T1.idestado,
                    T1.numero,
                    T1.nomproy,
                    T1.orden,
                    T1.responsable,
                    DATE_FORMAT(T1.feccotizacion, '%d/%m/%Y') AS feccotizacion,
                    DATE_FORMAT(T1.fecemision, '%d/%m/%Y') AS fecemision,
                    DATE_FORMAT(T1.fecinicio, '%d/%m/%Y') AS fecinicio,
                    DATE_FORMAT(T1.fecfin, '%d/%m/%Y') AS fecfin,
                    T1.valoferta,
                    T1.glosa,
                    T1.subtotal,
                    T1.igv,
                    T1.descuento,
                    T1.total,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_PROYECTO' AND TT.codigo = T1.idtipproy AND TT.eliminado = 0 LIMIT 1) AS dsctipproy,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'MONEDA' AND TT.codigo = T1.idmoneda AND TT.eliminado = 0 LIMIT 1) AS dscmoneda,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'ESTADO_COTIZACION' AND TT.codigo = T1.idestado AND TT.eliminado = 0 LIMIT 1) AS dscestado,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_CAMBIO' AND TT.codigo = '00001' AND TT.eliminado = 0 LIMIT 1) AS tipcamb,
                    DATEDIFF(T1.fecfin, T1.fecinicio) AS dias
                FROM
                    cotizacion T1
                    INNER JOIN proveedor T2 ON
                        T2.idproveedor = T1.idproveedor
                    INNER JOIN cliente T3 ON
                        T3.idcliente = T1.idcliente
                WHERE
                    COALESCE(?,0) IN (T1.idcotizacion,0)
                    AND COALESCE(?,0) IN (T1.idproveedor,0)
                    AND COALESCE(?,0) IN (T1.idcliente,0)
                    AND COALESCE(?,'') IN (T1.idtipproy,'')
                    AND COALESCE(?,'') IN (T1.numero,'')
                    AND COALESCE(?,'') IN (T1.orden,'')
                    AND UPPER(COALESCE(T1.nomproy,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND T1.eliminado = 0";
		
		$query = $this->db->query($sql, array($idCotizacion,
                                              $idProveedor,
                                              $idCliente,
                                              $idTipProy,                                              
                                              $numero,
                                              $orden,
                                              $nomProy));

		if($query)
		{
			$list = $query->result();

			foreach ($list as $row)
			{
				$oCotizacionBE = new CotizacionBE();
                $oCotiMaterialBE = new CotiMaterialBE();
                $oCotiOperarioBE = new CotiOperarioBE();
                $oCotiMovilizacionBE = new CotiMovilizacionBE();
                $oCotiCostoBE = new CotiCostoBE();
                $oProveedorBE = new ProveedorBE();
                $oClienteBE = new ClienteBE();
                
				$oCotizacionBE->idCotizacion = (int)$row->idcotizacion;
                $oCotizacionBE->idProveedor = (int)$row->idproveedor;
                $oCotizacionBE->idCliente = (int)$row->idcliente;
                $oCotizacionBE->idTipProy = $row->idtipproy;
                $oCotizacionBE->idMoneda = $row->idmoneda;
                $oCotizacionBE->idEstado = $row->idestado;
                $oCotizacionBE->numero = $row->numero;
                $oCotizacionBE->nomProy = $row->nomproy;
                $oCotizacionBE->orden = $row->orden;
                $oCotizacionBE->responsable = $row->responsable;
                $oCotizacionBE->fecCotizacion = $row->feccotizacion;
                $oCotizacionBE->fecEmision = $row->fecemision;
                $oCotizacionBE->fecInicio = $row->fecinicio;
                $oCotizacionBE->fecFin = $row->fecfin;
                $oCotizacionBE->valOferta = $row->valoferta;
                $oCotizacionBE->glosa = $row->glosa;
                $oCotizacionBE->subTotal = (double)$row->subtotal;
                $oCotizacionBE->igv = (double)$row->igv;
                $oCotizacionBE->descuento = (double)$row->descuento;
                $oCotizacionBE->total = (double)$row->total;
                $oCotizacionBE->dscTipProy = $row->dsctipproy;
                $oCotizacionBE->dscMoneda = $row->dscmoneda;
                $oCotizacionBE->dscEstado = $row->dscestado;
                $oCotizacionBE->tipCamb = (double)$row->tipcamb;
                $oCotizacionBE->dias = (int)$row->dias;

                $oCotiMaterialBE->idCotizacion = $oCotizacionBE->idCotizacion;
                $oCotiOperarioBE->idCotizacion = $oCotizacionBE->idCotizacion;
                $oCotiMovilizacionBE->idCotizacion = $oCotizacionBE->idCotizacion;
                $oCotiCostoBE->idCotizacion = $oCotizacionBE->idCotizacion;
                $oProveedorBE->idProveedor = $oCotizacionBE->idProveedor;
                $oClienteBE->idCliente = $oCotizacionBE->idCliente;

                $oCotizacionBE->listCotiMaterial = $this->cotiMaterialDAO->getCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);
                $oCotizacionBE->listCotiOperario = $this->cotiOperarioDAO->getCotiOperario($oCotiOperarioBE, $retorno, $mensaje);
                $oCotizacionBE->listCotiMovilizacion = $this->cotiMovilizacionDAO->getCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);
                $oCotizacionBE->listCotiCosto = $this->cotiCostoDAO->getCotiCosto($oCotiCostoBE, $retorno, $mensaje);
                $oCotizacionBE->proveedor = $this->proveedorDAO->getProveedor($oProveedorBE, $retorno, $mensaje)[0];
                $oCotizacionBE->cliente = $this->clienteDAO->getCliente($oClienteBE, $retorno, $mensaje)[0];

				array_push($listResult, $oCotizacionBE);
			}
			
			$retorno = 0;
			$mensaje = MSG_OK_GENERAL;
		}
		else
		{
			$retorno = 1;
			$mensaje = MSG_ERROR_GENERAL;
		}

		return $listResult;
    }
    
    public function createCotizacion($oCotizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');
        $this->load->model('CotiMaterialDAO', 'cotiMaterialDAO');
        $this->load->model('CotiOperarioDAO', 'cotiOperarioDAO');
        $this->load->model('CotiMovilizacionDAO', 'cotiMovilizacionDAO');
        $this->load->model('CotiCostoDAO', 'cotiCostoDAO');

        $objResult = null;

        $idProveedor = $oCotizacionBE->idProveedor;
        $idCliente = $oCotizacionBE->idCliente;
        $idTipProy = $oCotizacionBE->idTipProy;
        $idMoneda = $oCotizacionBE->idMoneda;
        $idEstado = $oCotizacionBE->idEstado;
        $numero = $oCotizacionBE->numero;
        $nomProy = $oCotizacionBE->nomProy;
        $orden = $oCotizacionBE->orden;
        $responsable = $oCotizacionBE->responsable;
        $fecCotizacion = $oCotizacionBE->fecCotizacion;
        $fecEmision = $oCotizacionBE->fecEmision;
        $fecInicio = $oCotizacionBE->fecInicio;
        $fecFin = $oCotizacionBE->fecFin;
        $valOferta = $oCotizacionBE->valOferta;
        $glosa = $oCotizacionBE->glosa;
        $subTotal = $oCotizacionBE->subTotal;
        $igv = $oCotizacionBE->igv;
        $descuento = $oCotizacionBE->descuento;
        $total = $oCotizacionBE->total;
        $idUsuCrea = $oCotizacionBE->idUsuCrea;

        $listCotiMaterial = $oCotizacionBE->listCotiMaterial;
        $listCotiOperario = $oCotizacionBE->listCotiOperario;
        $listCotiMovilizacion = $oCotizacionBE->listCotiMovilizacion;
        $listCotiCosto = $oCotizacionBE->listCotiCosto;                                

        $idCotizacion = $this->util->getNextId("cotizacion","idcotizacion");
        
        if ($idCotizacion > 0)
        {
            $sql = "INSERT INTO cotizacion
                    (
                        idcotizacion,
                        idproveedor,
                        idcliente,
                        idtipproy,
                        idmoneda,
                        idestado,
                        numero,
                        nomproy,
                        orden,
                        responsable,
                        feccotizacion,
                        fecemision,
                        fecinicio,
                        fecfin,
                        valoferta,
                        glosa,
                        subtotal,
                        igv,
                        descuento,
                        total,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idCotizacion,
                                                  $idProveedor,
                                                  $idCliente,
                                                  $idTipProy,
                                                  $idMoneda,
                                                  $idEstado,
                                                  $numero,
                                                  $nomProy,
                                                  $orden,
                                                  $responsable,
                                                  $fecCotizacion,
                                                  $fecEmision,
                                                  $fecInicio,
                                                  $fecFin,
                                                  $valOferta,
                                                  $glosa,
                                                  $subTotal,
                                                  $igv,
                                                  $descuento,
                                                  $total,
                                                  $idUsuCrea));

            if($query)
            {
                if ($listCotiMaterial != null && count($listCotiMaterial) > 0)
                {    
                    $oCotiMaterialBE = new CotiMaterialBE();

                    $oCotiMaterialBE->idCotizacion = $idCotizacion;

                    $obj = $this->cotiMaterialDAO->deleteCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);

                    foreach ($listCotiMaterial as $row)
                    {
                        $oCotiMaterialBE = new CotiMaterialBE();

                        $oCotiMaterialBE->idCotizacion = $idCotizacion;
                        $oCotiMaterialBE->idMaterial = $row['idMaterial'];
                        $oCotiMaterialBE->cantidad = $row['cantidad'];
                        $oCotiMaterialBE->precio = $row['precio'];
                        $oCotiMaterialBE->precioSoles = $row['precioSoles'];
                        $oCotiMaterialBE->total = $row['total'];
                        $oCotiMaterialBE->totalSoles = $row['totalSoles'];
                        $oCotiMaterialBE->idUsuCrea = $idUsuCrea;                        

                        $obj = $this->cotiMaterialDAO->createCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);
                    }
                }

                if ($listCotiOperario != null && count($listCotiOperario) > 0)
                {    
                    $oCotiOperarioBE = new CotiOperarioBE();

                    $oCotiOperarioBE->idCotizacion = $idCotizacion;

                    $obj = $this->cotiOperarioDAO->deleteCotiOperario($oCotiOperarioBE, $retorno, $mensaje);

                    foreach ($listCotiOperario as $row)
                    {
                        $oCotiOperarioBE = new CotiOperarioBE();

                        $oCotiOperarioBE->idCotizacion = $idCotizacion;
                        $oCotiOperarioBE->idOperario = $row['idOperario'];
                        $oCotiOperarioBE->fecIng = $row['fecIng'];
                        $oCotiOperarioBE->fecEgr = $row['fecEgr'];
                        $oCotiOperarioBE->costo = $row['costo'];
                        $oCotiOperarioBE->total = $row['total'];
                        $oCotiOperarioBE->idUsuCrea = $idUsuCrea;

                        $obj = $this->cotiOperarioDAO->createCotiOperario($oCotiOperarioBE, $retorno, $mensaje);
                    }
                }

                if ($listCotiMovilizacion != null && count($listCotiMovilizacion) > 0)
                {    
                    $oCotiMovilizacionBE = new CotiMovilizacionBE();

                    $oCotiMovilizacionBE->idCotizacion = $idCotizacion;

                    $obj = $this->cotiMovilizacionDAO->deleteCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);

                    foreach ($listCotiMovilizacion as $row)
                    {
                        $oCotiMovilizacionBE = new CotiMovilizacionBE();

                        $oCotiMovilizacionBE->idCotizacion = $idCotizacion;
                        $oCotiMovilizacionBE->semana = $row['semana'];
                        $oCotiMovilizacionBE->pasajes = $row['pasajes'];
                        $oCotiMovilizacionBE->alimentacion = $row['alimentacion'];                        
                        $oCotiMovilizacionBE->idUsuCrea = $idUsuCrea;

                        $obj = $this->cotiMovilizacionDAO->createCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);
                    }
                }

                if ($listCotiCosto != null && count($listCotiCosto) > 0)
                {    
                    $oCotiCostoBE = new CotiCostoBE();

                    $oCotiCostoBE->idCotizacion = $idCotizacion;

                    $obj = $this->cotiCostoDAO->deleteCotiCosto($oCotiCostoBE, $retorno, $mensaje);

                    foreach ($listCotiCosto as $row)
                    {
                        $oCotiCostoBE = new CotiCostoBE();

                        $oCotiCostoBE->idCotizacion = $idCotizacion;
                        $oCotiCostoBE->titulo = $row['titulo'];
                        $oCotiCostoBE->descripcion = $row['descripcion'];
                        $oCotiCostoBE->fecha = $row['fecha'];
                        $oCotiCostoBE->valor = $row['valor'];
                        $oCotiCostoBE->idUsuCrea = $idUsuCrea;

                        $obj = $this->cotiCostoDAO->createCotiCosto($oCotiCostoBE, $retorno, $mensaje);
                    }
                }

                $oCotizacionBE = new CotizacionBE();

                $oCotizacionBE->idCotizacion = $idCotizacion;

                $listResult = $this->getCotizacion($oCotizacionBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Cotizacion grabada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Ocurrió un error al obtener el codigo de Cotizacion";
        }
        

        return $objResult;
    }

    public function updateCotizacion($oCotizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');
        $this->load->model('CotiMaterialDAO', 'cotiMaterialDAO');
        $this->load->model('CotiOperarioDAO', 'cotiOperarioDAO');
        $this->load->model('CotiMovilizacionDAO', 'cotiMovilizacionDAO');
        $this->load->model('CotiCostoDAO', 'cotiCostoDAO');

        $objResult = null;

        $idCotizacion = $oCotizacionBE->idCotizacion;
        $idProveedor = $oCotizacionBE->idProveedor;
        $idCliente = $oCotizacionBE->idCliente;
        $idTipProy = $oCotizacionBE->idTipProy;
        $idMoneda = $oCotizacionBE->idMoneda;
        $idEstado = $oCotizacionBE->idEstado;
        $numero = $oCotizacionBE->numero;
        $nomProy = $oCotizacionBE->nomProy;
        $orden = $oCotizacionBE->orden;
        $responsable = $oCotizacionBE->responsable;
        $fecCotizacion = $oCotizacionBE->fecCotizacion;
        $fecEmision = $oCotizacionBE->fecEmision;
        $fecInicio = $oCotizacionBE->fecInicio;
        $fecFin = $oCotizacionBE->fecFin;
        $valOferta = $oCotizacionBE->valOferta;
        $glosa = $oCotizacionBE->glosa;
        $subTotal = $oCotizacionBE->subTotal;
        $igv = $oCotizacionBE->igv;
        $descuento = $oCotizacionBE->descuento;
        $total = $oCotizacionBE->total;
        $idUsuMod = $oCotizacionBE->idUsuMod;

        $listCotiMaterial = $oCotizacionBE->listCotiMaterial;
        $listCotiOperario = $oCotizacionBE->listCotiOperario;
        $listCotiMovilizacion = $oCotizacionBE->listCotiMovilizacion;
        $listCotiCosto = $oCotizacionBE->listCotiCosto;
        
        if ($idCotizacion > 0)
        {
            $oCotizacionBE = new CotizacionBE();

            $oCotizacionBE->idCotizacion = $idCotizacion;

            $listResult = $this->getCotizacion($oCotizacionBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {

                $sql = "UPDATE 
                            cotizacion
                        SET
                            idproveedor = COALESCE(?,idproveedor),
                            idcliente = COALESCE(?,idcliente),
                            idtipproy = COALESCE(?,idtipproy),
                            idmoneda = COALESCE(?,idmoneda),
                            idestado = COALESCE(?,idestado),
                            numero = COALESCE(?,numero),
                            nomproy = COALESCE(?,nomproy),
                            orden = COALESCE(?,orden),
                            responsable = COALESCE(?,responsable),
                            feccotizacion = COALESCE(?,feccotizacion),
                            fecemision = COALESCE(?,fecemision),
                            fecinicio = COALESCE(?,fecinicio),
                            fecfin = COALESCE(?,fecfin),
                            valoferta = COALESCE(?,valoferta),
                            glosa = COALESCE(?,glosa),
                            subtotal = COALESCE(?,subtotal),
                            igv = COALESCE(?,igv),
                            descuento = COALESCE(?,descuento),
                            total = COALESCE(?,total),
                            idusumod = COALESCE(?,idusumod),
                            fecusumod = NOW()
                        WHERE
                            idcotizacion = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idProveedor,
                                                      $idCliente,
                                                      $idTipProy,
                                                      $idMoneda,
                                                      $idEstado,
                                                      $numero,
                                                      $nomProy,
                                                      $orden,
                                                      $responsable,
                                                      $fecCotizacion,
                                                      $fecEmision,
                                                      $fecInicio,
                                                      $fecFin,
                                                      $valOferta,
                                                      $glosa,
                                                      $subTotal,
                                                      $igv,
                                                      $descuento,
                                                      $total,                                                      
                                                      $idUsuMod,                
                                                      $idCotizacion));

                if($query)
                {
                    if ($listCotiMaterial != null && count($listCotiMaterial) > 0)
                    {    
                        $oCotiMaterialBE = new CotiMaterialBE();

                        $oCotiMaterialBE->idCotizacion = $idCotizacion;

                        $obj = $this->cotiMaterialDAO->deleteCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);

                        foreach ($listCotiMaterial as $row)
                        {
                            $oCotiMaterialBE = new CotiMaterialBE();

                            $oCotiMaterialBE->idCotizacion = $idCotizacion;
                            $oCotiMaterialBE->idMaterial = $row['idMaterial'];
                            $oCotiMaterialBE->cantidad = $row['cantidad'];
                            $oCotiMaterialBE->precio = $row['precio'];
                            $oCotiMaterialBE->total = $row['total'];
                            $oCotiMaterialBE->idUsuCrea = $idUsuMod;                        

                            $obj = $this->cotiMaterialDAO->createCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);
                        }
                    }

                    if ($listCotiOperario != null && count($listCotiOperario) > 0)
                    {    
                        $oCotiOperarioBE = new CotiOperarioBE();

                        $oCotiOperarioBE->idCotizacion = $idCotizacion;

                        $obj = $this->cotiOperarioDAO->deleteCotiOperario($oCotiOperarioBE, $retorno, $mensaje);

                        foreach ($listCotiOperario as $row)
                        {
                            $oCotiOperarioBE = new CotiOperarioBE();

                            $oCotiOperarioBE->idCotizacion = $idCotizacion;
                            $oCotiOperarioBE->idOperario = $row['idOperario'];
                            $oCotiOperarioBE->fecIng = $row['fecIng'];
                            $oCotiOperarioBE->fecEgr = $row['fecEgr'];
                            $oCotiOperarioBE->costo = $row['costo'];
                            $oCotiOperarioBE->total = $row['total'];
                            $oCotiOperarioBE->idUsuCrea = $idUsuMod;

                            $obj = $this->cotiOperarioDAO->createCotiOperario($oCotiOperarioBE, $retorno, $mensaje);
                        }
                    }

                    if ($listCotiMovilizacion != null && count($listCotiMovilizacion) > 0)
                    {    
                        $oCotiMovilizacionBE = new CotiMovilizacionBE();

                        $oCotiMovilizacionBE->idCotizacion = $idCotizacion;

                        $obj = $this->cotiMovilizacionDAO->deleteCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);

                        foreach ($listCotiMovilizacion as $row)
                        {
                            $oCotiMovilizacionBE = new CotiMovilizacionBE();

                            $oCotiMovilizacionBE->idCotizacion = $idCotizacion;
                            $oCotiMovilizacionBE->semana = $row['semana'];
                            $oCotiMovilizacionBE->pasajes = $row['pasajes'];
                            $oCotiMovilizacionBE->alimentacion = $row['alimentacion'];                        
                            $oCotiMovilizacionBE->idUsuCrea = $idUsuMod;

                            $obj = $this->cotiMovilizacionDAO->createCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);
                        }
                    }

                    if ($listCotiCosto != null && count($listCotiCosto) > 0)
                    {    
                        $oCotiCostoBE = new CotiCostoBE();

                        $oCotiCostoBE->idCotizacion = $idCotizacion;

                        $obj = $this->cotiCostoDAO->deleteCotiCosto($oCotiCostoBE, $retorno, $mensaje);

                        foreach ($listCotiCosto as $row)
                        {
                            $oCotiCostoBE = new CotiCostoBE();

                            $oCotiCostoBE->idCotizacion = $idCotizacion;
                            $oCotiCostoBE->titulo = $row['titulo'];
                            $oCotiCostoBE->descripcion = $row['descripcion'];
                            $oCotiCostoBE->fecha = $row['fecha'];
                            $oCotiCostoBE->valor = $row['valor'];
                            $oCotiCostoBE->idUsuCrea = $idUsuMod;

                            $obj = $this->cotiCostoDAO->createCotiCosto($oCotiCostoBE, $retorno, $mensaje);
                        }
                    }

                    $oCotizacionBE = new CotizacionBE();

                    $oCotizacionBE->idCotizacion = $idCotizacion;

                    $listResult = $this->getCotizacion($oCotizacionBE, $retorno, $mensaje);

                    if(count($listResult) > 0)
                    {
                        $objResult = $listResult[0];

                        $retorno = 0;
                        $mensaje = "Cotizacion Grabado Correctamente";
                    }
                    else
                    {
                        $retorno = 1;
                        $mensaje = MSG_ERROR_GENERAL;
                    }
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Cotizacion no Existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe Ingresar el Codigo de Cotizacion";
        }

        return $objResult;        
    }

    public function deleteCotizacion($oCotizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('CotiMaterialDAO', 'cotiMaterialDAO');
        $this->load->model('CotiOperarioDAO', 'cotiOperarioDAO');
        $this->load->model('CotiMovilizacionDAO', 'cotiMovilizacionDAO');
        $this->load->model('CotiCostoDAO', 'cotiCostoDAO');

        $objResult = null;

        $idCotizacion = $oCotizacionBE->idCotizacion;
        $idUsuMod = $oCotizacionBE->idUsuMod;
        
        if ($idCotizacion > 0)
        {                                
            $oCotizacionBE = new CotizacionBE();

            $oCotizacionBE->idCotizacion = $idCotizacion;

            $listResult = $this->getCotizacion($oCotizacionBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {                
                $sql = "UPDATE 
                            cotizacion
                        SET
                            idusumod = ?,
                            fecusumod = NOW(),
                            eliminado = 1
                        WHERE
                            idcotizacion = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idUsuMod, $idCotizacion));

                if($query)
                {
                    $oCotiMaterialBE = new CotiMaterialBE();
                    $oCotiOperarioBE = new CotiOperarioBE();
                    $oCotiMovilizacionBE = new CotiMovilizacionBE();
                    $oCotiCostoBE = new CotiCostoBE();

                    $oCotiMaterialBE->idCotizacion = $idCotizacion;
                    $oCotiOperarioBE->idCotizacion = $idCotizacion;
                    $oCotiMovilizacionBE->idCotizacion = $idCotizacion;
                    $oCotiCostoBE->idCotizacion = $idCotizacion;

                    $obj = $this->cotiMaterialDAO->deleteCotiMaterial($oCotiMaterialBE, $retorno, $mensaje);
                    $obj = $this->cotiOperarioDAO->deleteCotiOperario($oCotiOperarioBE, $retorno, $mensaje);
                    $obj = $this->cotiMovilizacionDAO->deleteCotiMovilizacion($oCotiMovilizacionBE, $retorno, $mensaje);
                    $obj = $this->cotiCostoDAO->deleteCotiCosto($oCotiCostoBE, $retorno, $mensaje);

                    $retorno = 0;
                    $mensaje = "Cotizacion eliminada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "La Cotizacion no existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Cotizacion";
        }

        return $objResult;
    }    
}
?>