<?php

class OperarioDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getOperario($oOperarioBE, &$retorno, &$mensaje)
    {
        $idOperario = $oOperarioBE->idOperario;        
        $idTipDoc = $oOperarioBE->idTipDoc;
        $numDoc = $oOperarioBE->numDoc;
        $nombres = $oOperarioBE->nombres;
        $apellidos = $oOperarioBE->apellidos;              

        $listResult = array();
              
        $sql = "SELECT
                    T1.idoperario,                    
                    T1.idtipdoc,
                    T1.numdoc,
                    T1.nombres,
                    T1.apellidos,
                    T1.especialidad,
                    T1.telefono,
                    T1.email,
                    T1.direccion,
                    T1.sctr,
                    DATE_FORMAT(T1.fecnacimiento, '%d/%m/%Y') AS fecnacimiento,
                    T1.costo,
                    (SELECT TT.abreviatura FROM parametro TT WHERE TT.tipparam = 'TIPO_DOCUMENTO' AND TT.codigo = T1.idtipdoc AND TT.eliminado = 0 LIMIT 1) AS dsctipdoc,
                    CONCAT(COALESCE(T1.nombres,''),' ',COALESCE(T1.apellidos,'')) AS nomcompleto
                FROM
                    operario T1
                WHERE
                    COALESCE(?,0) IN (T1.idoperario,0)                    
                    AND COALESCE(?,'') IN (T1.idtipdoc,'')
                    AND COALESCE(?,'') IN (T1.numdoc,'')
                    AND UPPER(COALESCE(T1.nombres,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND UPPER(COALESCE(T1.apellidos,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')                    
                    AND T1.eliminado = 0
                ORDER BY
                    4";
        
        $query = $this->db->query($sql, array($idOperario,                                              
                                              $idTipDoc,
                                              $numDoc,
                                              $nombres,
                                              $apellidos));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oOperarioBE = new OperarioBE();

            $oOperarioBE->idOperario = (int)$row->idoperario;            
            $oOperarioBE->idTipDoc = $row->idtipdoc;
            $oOperarioBE->numDoc = $row->numdoc;
            $oOperarioBE->nombres = $row->nombres;
            $oOperarioBE->apellidos = $row->apellidos;
            $oOperarioBE->especialidad = $row->especialidad;
            $oOperarioBE->telefono = $row->telefono;
            $oOperarioBE->email = $row->email;
            $oOperarioBE->direccion = $row->direccion;
            $oOperarioBE->sctr = $row->sctr; 
            $oOperarioBE->fecNacimiento = $row->fecnacimiento;
            $oOperarioBE->costo = (double)$row->costo;            
            $oOperarioBE->dscTipDoc = $row->dsctipdoc;
            $oOperarioBE->nomCompleto = $row->nomcompleto;

            array_push($listResult, $oOperarioBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createOperario($oOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;

        $idTipDoc = $oOperarioBE->idTipDoc;
        $numDoc = $oOperarioBE->numDoc;
        $nombres = $oOperarioBE->nombres;
        $apellidos = $oOperarioBE->apellidos;
        $especialidad = $oOperarioBE->especialidad;
        $telefono = $oOperarioBE->telefono;
        $email = $oOperarioBE->email;
        $direccion = $oOperarioBE->direccion;
        $sctr = $oOperarioBE->sctr;
        $fecNacimiento = $oOperarioBE->fecNacimiento;
        $costo = $oOperarioBE->costo;
        $idUsuCrea = $oOperarioBE->idUsuCrea;

        $idOperario = $this->util->getNextId("operario","idoperario");
                
        if ($idOperario > 0)
        {
            $sql = "INSERT INTO operario
                    (
                        idoperario,
                        idtipdoc,
                        numdoc,
                        nombres,
                        apellidos,
                        especialidad,
                        telefono,
                        email,
                        direccion,
                        sctr,
                        fecnacimiento,
                        costo,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idOperario,
                                                  $idTipDoc,
                                                  $numDoc,
                                                  $nombres,
                                                  $apellidos,
                                                  $especialidad,
                                                  $telefono,
                                                  $email,
                                                  $direccion,
                                                  $sctr,
                                                  $fecNacimiento,
                                                  $costo,
                                                  $idUsuCrea));

            if($query)
            {
                $oOperarioBE = new OperarioBE();

                $oOperarioBE->idOperario = $idOperario;

                $listResult = $this->getOperario($oOperarioBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Operario grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Ocurrió un error al obtener el codigo de Operario";
        }

        return $objResult;
    }

    public function updateOperario($oOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idOperario = $oOperarioBE->idOperario;
        $idTipDoc = $oOperarioBE->idTipDoc;
        $numDoc = $oOperarioBE->numDoc;
        $nombres = $oOperarioBE->nombres;
        $apellidos = $oOperarioBE->apellidos;
        $especialidad = $oOperarioBE->especialidad;
        $telefono = $oOperarioBE->telefono;
        $email = $oOperarioBE->email;
        $direccion = $oOperarioBE->direccion;
        $sctr = $oOperarioBE->sctr;
        $fecNacimiento = $oOperarioBE->fecNacimiento;
        $costo = $oOperarioBE->costo;        
        $idUsuMod = $oOperarioBE->idUsuMod;        
        
        if ($idOperario > 0)
        {
            $oOperarioBE = new OperarioBE();

            $oOperarioBE->idOperario = $idOperario;

            $listResult = $this->getOperario($oOperarioBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {
                $sql = "UPDATE 
                            operario
                        SET                            
                            idtipdoc = COALESCE(?,idtipdoc),
                            numdoc = COALESCE(?,numdoc),
                            nombres = COALESCE(?,nombres),
                            apellidos = COALESCE(?,apellidos),
                            especialidad = COALESCE(?,especialidad),
                            telefono = COALESCE(?,telefono),
                            email = COALESCE(?,email),
                            direccion = COALESCE(?,direccion),
                            sctr = COALESCE(?,sctr),
                            fecnacimiento = COALESCE(?,fecnacimiento),
                            costo = COALESCE(?,costo),
                            idusumod = COALESCE(?,idusumod),
                            fecusumod = NOW()
                        WHERE
                            idoperario = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idTipDoc,
                                                      $numDoc,
                                                      $nombres,
                                                      $apellidos,
                                                      $especialidad,
                                                      $telefono,
                                                      $email,
                                                      $direccion,
                                                      $sctr,
                                                      $fecNacimiento,
                                                      $costo,
                                                      $idUsuMod,
                                                      $idOperario));

                if($query)
                {
                    $oOperarioBE = new OperarioBE();

                    $oOperarioBE->idOperario = $idOperario;

                    $listResult = $this->getOperario($oOperarioBE, $retorno, $mensaje);

                    if(count($listResult) > 0)
                    {
                        $objResult = $listResult[0];

                        $retorno = 0;
                        $mensaje = "Operario grabado correctamente";
                    }
                    else
                    {
                        $retorno = 1;
                        $mensaje = MSG_ERROR_GENERAL;
                    }
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Operario no existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Operario";
        }

        return $objResult;
    }

    public function deleteOperario($oOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idOperario = $oOperarioBE->idOperario;        
        $idUsuMod = $oOperarioBE->idUsuMod;
        
        if ($idOperario > 0)
        {
            $oOperarioBE = new OperarioBE();

            $oOperarioBE->idOperario = $idOperario;

            $listResult = $this->getOperario($oOperarioBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {                
                $sql = "UPDATE 
                           operario
                        SET
                           idusumod = ?,
                           fecusumod = NOW(),
                           eliminado = 1
                        WHERE
                           idoperario = ?
                           AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idUsuMod,
                                                      $idOperario));
                if($query)
                {
                    $retorno = 0;
                    $mensaje = "Operario eliminado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Operario no existe";
            }                    
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Operario";
        }

        return $objResult;
    }    
}
?>