<?php

class ParametroDAO extends CI_Model 
{
	public function __construct()
	{		 
	  parent::__construct();
  }

  public function getParametro($oParametroBE, &$retorno, &$mensaje)
	{		
    $idParam = $oParametroBE->idParam;
    $tipParam = $oParametroBE->tipParam;
    $codigo = $oParametroBE->codigo;
    $codPadre = $oParametroBE->codPadre;
    $descripcion = $oParametroBE->descripcion;
        
		$listResult = array();
		
    $sql = "SELECT
              T1.idparam,
              T1.tipparam,
              T1.codigo,
              T1.codpadre,
              T1.descripcion,
              T1.abreviatura,
              T1.observacion
            FROM
              parametro T1
            WHERE
              COALESCE(?,0) IN (T1.idparam,0)
              AND COALESCE(?,'') IN (T1.tipparam,'')
              AND COALESCE(?,'') IN (T1.codigo,'')
	            AND COALESCE(?,'') IN (T1.codpadre,'')
              AND UPPER(CONCAT(T1.descripcion)) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
              AND T1.eliminado = 0
            ORDER BY
              5";

    $query = $this->db->query($sql, array($idParam,
                                          $tipParam,
                                          $codigo,
                                          $codPadre,
                                          $descripcion));

    if($query)
    {
      $list = $query->result();

      foreach ($list as $row)
      {
        $oParametroBE = new ParametroBE();				
                
        $oParametroBE->idParam = (int)$row->idparam;
        $oParametroBE->tipParam = $row->tipparam;
        $oParametroBE->codigo = $row->codigo;
        $oParametroBE->codPadre = $row->codpadre;
        $oParametroBE->descripcion = $row->descripcion;
        $oParametroBE->abreviatura = $row->abreviatura;
        $oParametroBE->observacion = $row->observacion;

        array_push($listResult, $oParametroBE);
      }
      
      $retorno = 0;
      $mensaje = MSG_OK_GENERAL;
    }
    else
    {
      $retorno = 1;
      $mensaje = MSG_ERROR_GENERAL;
    }

    return $listResult;
  }

  public function createParametro($oParametroBE, &$retorno, &$mensaje)
  {
    $this->load->model('UtilDAO', 'util');

    $objResult = null;
                        
    $idParam = $oParametroBE->idParam;
    $tipParam = $oParametroBE->tipParam;
    $codigo = $oParametroBE->codigo;
    $codPadre = $oParametroBE->codPadre;
    $descripcion = $oParametroBE->descripcion;
    $abreviatura = $oParametroBE->abreviatura;
    $observacion = $oParametroBE->observacion;
    $idUsuCrea = $oParametroBE->idUsuCrea;

    $idParam = $this->util->getNextId("parametro","idparam");
    
    if ($idParam > 0)
    {
      $sql = "INSERT INTO parametro
              (
                idparam,
                tipparam,
                codigo,
                codpadre,
                descripcion,
                abreviatura,
                observacion,
                idusucrea,
                fecusucrea,
                idusumod,
                fecusumod,
                eliminado
              )
              VALUES
              (
                ?,
                ?,
                ?,
                ?,
                ?,
                ?,
                ?,
                ?,
                NOW(),
                NULL,
                NULL,
                0
              )";
              
      $query = $this->db->query($sql, array($idParam,
                                            $tipParam,
                                            $codigo,
                                            $codPadre,
                                            $descripcion,
                                            $abreviatura,
                                            $observacion,
                                            $idUsuCrea));

      if($query)
      {        
          $oParametroBE = new ParametroBE();

          $oParametroBE->idParam = $idParam;

          $listResult = $this->getParametro($oParametroBE, $retorno, $mensaje);

          if(count($listResult) > 0)
          {
              $objResult = $listResult[0];

              $retorno = 0;
              $mensaje = "Parametro grabado satisfactoriamente";
          }
          else
          {
              $retorno = 1;
              $mensaje = MSG_ERROR_GENERAL;
          }        
      }
      else
      {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
      }
    }
    else
    {
        $retorno = 1;
        $mensaje = "Ocurrió un error al obtener el codigo de Parametro";
    }

    return $objResult;
  }

  public function updateParametro($oParametroBE, &$retorno, &$mensaje)
  {
    $this->load->model('UtilDAO', 'util');

    $objResult = null;
    
    $idParam = $oParametroBE->idParam;
    $tipParam = $oParametroBE->tipParam;
    $codigo = $oParametroBE->codigo;
    $codPadre = $oParametroBE->codPadre;
    $descripcion = $oParametroBE->descripcion;
    $abreviatura = $oParametroBE->abreviatura;
    $observacion = $oParametroBE->observacion;
    $idUsuMod = $oParametroBE->idUsuMod;
    
    if ($idParam > 0)
    {
      $oParametroBE = new ParametroBE();

      $oParametroBE->idParam = $idParam;

      $listResult = $this->getParametro($oParametroBE, $retorno, $mensaje);

      if(count($listResult) > 0)
      {
        $sql = "UPDATE 
                  parametro
                SET                        
                  tipparam = COALESCE(?,tipparam),
                  codigo = COALESCE(?,codigo),
                  codpadre = COALESCE(?,codpadre),
                  descripcion = COALESCE(?,descripcion),
                  abreviatura = COALESCE(?,abreviatura),
                  observacion = COALESCE(?,observacion),
                  idusumod = COALESCE(?,idusumod),
                  fecusumod = NOW()
                WHERE
                  idparam = ?
                  AND eliminado = 0";
                
        $query = $this->db->query($sql, array($tipParam,
                                              $codigo,
                                              $codPadre,
                                              $descripcion,
                                              $abreviatura,
                                              $observacion,                                          
                                              $idUsuMod,
                                              $idParam));

        if($query)
        {                
            $oParametroBE = new ParametroBE();

            $oParametroBE->idParam = $idParam;

            $listResult = $this->getParametro($oParametroBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {
                $objResult = $listResult[0];

                $retorno = 0;
                $mensaje = "Parametro grabado satisfactoriamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }        
        }
        else
        {
            $retorno = 1;
            $mensaje = MSG_ERROR_GENERAL;
        }
      }
      else
      {
          $retorno = 1;
          $mensaje = "El Parametro no existe";
      }
      
    }
    else
    {
        $retorno = 1;
        $mensaje = "Debe ingresar el codigo de Parametro";
    }

    return $objResult;
  }

  public function deleteParametro($oParametroBE, &$retorno, &$mensaje)
  {
    $objResult = null;
    
    $idParam = $oParametroBE->idParam;
    $idUsuMod = $oParametroBE->idUsuMod;    
    
    if ($idParam > 0)
    {
      $oParametroBE = new ParametroBE();

      $oParametroBE->idParam = $idParam;

      $listResult = $this->getParametro($oParametroBE, $retorno, $mensaje);

      if(count($listResult) > 0)
      {
        $sql = "UPDATE 
                  parametro
                SET
                  idusumod = ?,
                  fecusumod = NOW(),
                  eliminado = 1
                WHERE
                  idparam = ?
                  AND eliminado = 0";
                
        $query = $this->db->query($sql, array($idUsuMod,$idParam));

        if($query)
        {        
            if($query)
            {
              $retorno = 0;
              $mensaje = "Parametro eliminado satisfactoriamente";
            } 
            else
            {
              $retorno = 1;
              $mensaje = MSG_ERROR_GENERAL;
            }	            
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }
      }
      else
      {
          $retorno = 1;
          $mensaje = "El Parametro no existe";
      }
    }
    else
    {
        $retorno = 1;
        $mensaje = "Debe ingresar el codigo de Parametro";
    }

    return $objResult;
  }
}

?>