<?php

class PerfilDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getPerfil($oPerfilBE, &$retorno, &$mensaje)
    {
        $idPerfil = $oPerfilBE->idPerfil;
        $nombre = $oPerfilBE->nombre;    

        $listResult = array();
              
        $sql = "SELECT
                    T1.idperfil,
                    T1.nombre,
                    T1.observacion
                FROM
                    perfil T1
                WHERE
                    COALESCE(?,0) IN (T1.idperfil,0)
                    AND UPPER(COALESCE(T1.nombre,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND T1.eliminado = 0
                ORDER BY
                    2";
        
        $query = $this->db->query($sql, array($idPerfil, $nombre));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oPerfilBE = new PerfilBE();

            $oPerfilBE->idPerfil = (int)$row->idperfil;
            $oPerfilBE->nombre = $row->nombre;
            $oPerfilBE->observacion = $row->observacion;

            array_push($listResult, $oPerfilBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createPerfil($oPerfilBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $nombre = $oPerfilBE->nombre;
        $observacion = $oPerfilBE->observacion;
        $idUsuCrea = $oPerfilBE->idUsuCrea;

        $idPerfil = $this->util->getNextId("perfil","idperfil");
                
        if ($idPerfil > 0)
        {
            $sql = "INSERT INTO perfil
                    (
                      idperfil,
                      nombre,
                      observacion,
                      idusucrea,
                      fecusucrea,
                      idusumod,
                      fecusumod,
                      eliminado
                    )
                    VALUES
                    (
                      ?,
                      ?,
                      ?,
                      ?,
                      NOW(),
                      NULL,
                      NULL,
                      0
                    )";
                
            $query = $this->db->query($sql, array($idPerfil,
                                                  $nombre,
                                                  $observacion,
                                                  $idUsuCrea));

            if($query)
            {
                $oPerfilBE = new PerfilBE();

                $oPerfilBE->idPerfil = $idPerfil;

                $listResult = $this->getPerfil($oPerfilBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Perfil grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Ocurrió un error al obtener el codigo de Perfil";
        }

        return $objResult;
    }

    public function updatePerfil($oPerfilBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idPerfil = $oPerfilBE->idPerfil;
        $nombre = $oPerfilBE->nombre;
        $observacion = $oPerfilBE->observacion;

        $idUsuMod = $oPerfilBE->idUsuMod;
        
        if ($idPerfil > 0)
        {
            $oPerfilBE = new PerfilBE();

            $oPerfilBE->idPerfil = $idPerfil;

            $listResult = $this->getPerfil($oPerfilBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {
                $sql = "UPDATE 
                            perfil
                        SET                        
                            nombre = COALESCE(?,nombre),
                            observacion = COALESCE(?,observacion),
                            idusumod = COALESCE(?,idusumod),
                            fecusumod = NOW()
                        WHERE
                            idperfil = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($nombre,
                                                      $observacion,
                                                      $idUsuMod,                                                      
                                                      $idPerfil));
                if($query)
                {
                    $oPerfilBE = new PerfilBE();

                    $oPerfilBE->idPerfil = $idPerfil;

                    $listResult = $this->getPerfil($oPerfilBE, $retorno, $mensaje);

                    if(count($listResult) > 0)
                    {
                        $objResult = $listResult[0];

                        $retorno = 0;
                        $mensaje = "Perfil grabado correctamente";
                    }
                    else
                    {
                        $retorno = 1;
                        $mensaje = MSG_ERROR_GENERAL;
                    }
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Perfil no existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Perfil";
        }

        return $objResult;
    }

    public function deletePerfil($oPerfilBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idPerfil = $oPerfilBE->idPerfil;        
        $idUsuMod = $oPerfilBE->idUsuMod;
        
        if ($idPerfil > 0)
        {
            $oPerfilBE = new PerfilBE();

            $oPerfilBE->idPerfil = $idPerfil;

            $listResult = $this->getPerfil($oPerfilBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {                
                $sql = "UPDATE 
                           perfil
                        SET
                           idusumod = ?,
                           fecusumod = NOW(),
                           eliminado = 1
                        WHERE
                           idperfil = ?
                           AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idUsuMod,
                                                      $idPerfil));
                if($query)
                {
                    $retorno = 0;
                    $mensaje = "Perfil eliminado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Perfil no existe";
            }                    
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Perfil";
        }

        return $objResult;
    }    
}
?>