<?php

class ProveedorDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getProveedor($oProveedorBE, &$retorno, &$mensaje)
    {
        $idProveedor = $oProveedorBE->idProveedor;
        $idTipo = $oProveedorBE->idTipo;
        $idTipDoc = $oProveedorBE->idTipDoc;
        $numDoc = $oProveedorBE->numDoc;
        $nombres = $oProveedorBE->nombres;
        $apellidos = $oProveedorBE->apellidos;
        $razonSocial = $oProveedorBE->razonSocial;        

        $listResult = array();
              
        $sql = "SELECT
                    T1.idproveedor,
                    T1.idtipo,
                    T1.idtipdoc,
                    T1.numdoc,
                    T1.nombres,
                    T1.apellidos,
                    T1.razonsocial,
                    T1.telefono,
                    T1.email,
                    T1.direccion,	
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_PERSONA' AND TT.codigo = T1.idtipo AND TT.eliminado = 0 LIMIT 1) AS dsctipo,
                    (SELECT TT.abreviatura FROM parametro TT WHERE TT.tipparam = 'TIPO_DOCUMENTO' AND TT.codigo = T1.idtipdoc AND TT.eliminado = 0 LIMIT 1) AS dsctipdoc,
                    (CASE T1.idtipo
                        WHEN '00001' THEN CONCAT(COALESCE(T1.nombres,''),' ',COALESCE(T1.apellidos,''))
                        WHEN '00002' THEN T1.razonsocial
                        ELSE ''
                    END) AS nomcompleto
                FROM
                    proveedor T1
                WHERE
                    COALESCE(?,0) IN (T1.idproveedor,0)
                    AND COALESCE(?,'') IN (T1.idtipo,'')
                    AND COALESCE(?,'') IN (T1.idtipdoc,'')
                    AND COALESCE(?,'') IN (T1.numdoc,'')
                    AND UPPER(COALESCE(T1.nombres,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND UPPER(COALESCE(T1.apellidos,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND UPPER(COALESCE(T1.razonsocial,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')                    
                    AND T1.eliminado = 0
                ORDER BY
                    5";
        
        $query = $this->db->query($sql, array($idProveedor,
                                              $idTipo,
                                              $idTipDoc,
                                              $numDoc,
                                              $nombres,
                                              $apellidos,
                                              $razonSocial));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oProveedorBE = new ProveedorBE();

            $oProveedorBE->idProveedor = (int)$row->idproveedor;
            $oProveedorBE->idTipo = $row->idtipo;
            $oProveedorBE->idTipDoc = $row->idtipdoc;
            $oProveedorBE->numDoc = $row->numdoc;
            $oProveedorBE->nombres = $row->nombres;
            $oProveedorBE->apellidos = $row->apellidos;
            $oProveedorBE->razonSocial = $row->razonsocial;
            $oProveedorBE->telefono = $row->telefono;
            $oProveedorBE->email = $row->email;
            $oProveedorBE->direccion = $row->direccion;            
            $oProveedorBE->dscTipo = $row->dsctipo;
            $oProveedorBE->dscTipDoc = $row->dsctipdoc;
            $oProveedorBE->nomCompleto = $row->nomcompleto;

            array_push($listResult, $oProveedorBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createProveedor($oProveedorBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                        
        $idTipo = $oProveedorBE->idTipo;
        $idTipDoc = $oProveedorBE->idTipDoc;
        $numDoc = $oProveedorBE->numDoc;
        $nombres = $oProveedorBE->nombres;
        $apellidos = $oProveedorBE->apellidos;
        $razonSocial = $oProveedorBE->razonSocial;
        $telefono = $oProveedorBE->telefono;
        $email = $oProveedorBE->email;
        $direccion = $oProveedorBE->direccion;
        $idUsuCrea = $oProveedorBE->idUsuCrea;

        $idProveedor = $this->util->getNextId("proveedor","idproveedor");
                
        if ($idProveedor > 0)
        {
            $sql = "INSERT INTO proveedor
                    (
                        idproveedor,
                        idtipo,
                        idtipdoc,
                        numdoc,
                        nombres,
                        apellidos,
                        razonsocial,
                        telefono,
                        email,
                        direccion,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idProveedor,
                                                  $idTipo,
                                                  $idTipDoc,
                                                  $numDoc,
                                                  $nombres,
                                                  $apellidos,
                                                  $razonSocial,
                                                  $telefono,
                                                  $email,
                                                  $direccion,
                                                  $idUsuCrea));

            if($query)
            {
                $oProveedorBE = new ProveedorBE();

                $oProveedorBE->idProveedor = $idProveedor;

                $listResult = $this->getProveedor($oProveedorBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Proveedor grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Ocurrió un error al obtener el codigo de Proveedor";
        }

        return $objResult;
    }

    public function updateProveedor($oProveedorBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idProveedor = $oProveedorBE->idProveedor;
        $idTipo = $oProveedorBE->idTipo;
        $idTipDoc = $oProveedorBE->idTipDoc;
        $numDoc = $oProveedorBE->numDoc;
        $nombres = $oProveedorBE->nombres;
        $apellidos = $oProveedorBE->apellidos;
        $razonSocial = $oProveedorBE->razonSocial;
        $telefono = $oProveedorBE->telefono;
        $email = $oProveedorBE->email;
        $direccion = $oProveedorBE->direccion;        
        $idUsuMod = $oProveedorBE->idUsuMod;

        $idUsuMod = $oProveedorBE->idUsuMod;
        
        if ($idProveedor > 0)
        {
            $oProveedorBE = new ProveedorBE();

            $oProveedorBE->idProveedor = $idProveedor;

            $listResult = $this->getProveedor($oProveedorBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {
                $sql = "UPDATE 
                            proveedor
                        SET
                            idtipo = COALESCE(?,idtipo),
                            idtipdoc = COALESCE(?,idtipdoc),
                            numdoc = COALESCE(?,numdoc),
                            nombres = COALESCE(?,nombres),
                            apellidos = COALESCE(?,apellidos),
                            razonsocial = COALESCE(?,razonsocial),
                            telefono = COALESCE(?,telefono),
                            email = COALESCE(?,email),
                            direccion = COALESCE(?,direccion),	
                            idusumod = COALESCE(?,idusumod),
                            fecusumod = NOW()
                        WHERE
                            idproveedor = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idTipo,
                                                      $idTipDoc,
                                                      $numDoc,
                                                      $nombres,
                                                      $apellidos,
                                                      $razonSocial,
                                                      $telefono,
                                                      $email,
                                                      $direccion,                
                                                      $idUsuMod,
                                                      $idProveedor));

                if($query)
                {
                    $oProveedorBE = new ProveedorBE();

                    $oProveedorBE->idProveedor = $idProveedor;

                    $listResult = $this->getProveedor($oProveedorBE, $retorno, $mensaje);

                    if(count($listResult) > 0)
                    {
                        $objResult = $listResult[0];

                        $retorno = 0;
                        $mensaje = "Proveedor grabado correctamente";
                    }
                    else
                    {
                        $retorno = 1;
                        $mensaje = MSG_ERROR_GENERAL;
                    }
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Proveedor no existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proveedor";
        }

        return $objResult;
    }

    public function deleteProveedor($oProveedorBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idProveedor = $oProveedorBE->idProveedor;        
        $idUsuMod = $oProveedorBE->idUsuMod;
        
        if ($idProveedor > 0)
        {
            $oProveedorBE = new ProveedorBE();

            $oProveedorBE->idProveedor = $idProveedor;

            $listResult = $this->getProveedor($oProveedorBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {                
                $sql = "UPDATE 
                           proveedor
                        SET
                           idusumod = ?,
                           fecusumod = NOW(),
                           eliminado = 1
                        WHERE
                           idproveedor = ?
                           AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idUsuMod,
                                                      $idProveedor));
                if($query)
                {
                    $retorno = 0;
                    $mensaje = "Proveedor eliminado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Proveedor no existe";
            }                    
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proveedor";
        }

        return $objResult;
    }    
}
?>