<?php

class ProyCostoDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getProyCosto($oProyCostoBE, &$retorno, &$mensaje)
    {
        $idProyecto = $oProyCostoBE->idProyecto;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idproyecto,
                    T1.titulo,
                    T1.descripcion,
                    DATE_FORMAT(T1.fecha, '%d/%m/%Y') AS fecha,
                    T1.valor
                FROM
                    proycosto T1
                WHERE
                    COALESCE(?,0) IN (T1.idproyecto,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,2";
        
        $query = $this->db->query($sql, array($idProyecto));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oProyCostoBE = new ProyCostoBE();

            $oProyCostoBE->idProyecto = (int)$row->idproyecto;
            $oProyCostoBE->titulo = $row->titulo;
            $oProyCostoBE->descripcion = $row->descripcion;
            $oProyCostoBE->fecha = $row->fecha;
            $oProyCostoBE->valor = (double)$row->valor;

            array_push($listResult, $oProyCostoBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createProyCosto($oProyCostoBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idProyecto = $oProyCostoBE->idProyecto;
        $titulo = $oProyCostoBE->titulo;
        $descripcion = $oProyCostoBE->descripcion;
        $fecha = $oProyCostoBE->fecha;
        $valor = $oProyCostoBE->valor;
        $idUsuCrea = $oProyCostoBE->idUsuCrea;
                
        if ($idProyecto > 0)
        {
            $sql = "INSERT INTO proycosto
                    (
                        idproyecto,
                        titulo,
                        descripcion,
                        fecha,
                        valor,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idProyecto,
                                                  $titulo,
                                                  $descripcion,
                                                  $fecha,
                                                  $valor,
                                                  $idUsuCrea));

            if($query)
            {
                $oProyCostoBE = new ProyCostoBE();

                $oProyCostoBE->idProyecto = $idProyecto;                

                $listResult = $this->getProyCosto($oProyCostoBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Costo de cotizacion grabada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }

    public function deleteProyCosto($oProyCostoBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idProyecto = $oProyCostoBE->idProyecto;                
        
        if ($idProyecto > 0)
        {            
            $sql = "DELETE FROM proycosto WHERE idproyecto=?";
                
            $query = $this->db->query($sql, array($idProyecto));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Costos de Proyecto eliminados correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }
}
?>