<?php

class ProyMaterialDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getProyMaterial($oProyMaterialBE, &$retorno, &$mensaje)
    {
        $idProyecto = $oProyMaterialBE->idProyecto;
        $idMaterial = $oProyMaterialBE->idMaterial;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idproyecto,
                    T1.idmaterial,
                    T1.cantidad,
                    T1.precio,
                    (CASE
                        WHEN T4.idestado = '00001' THEN ROUND(T1.precio*(SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_CAMBIO' AND TT.codigo = '00001' AND TT.eliminado = 0 LIMIT 1),2) 
                        ELSE T1.preciosoles
                    END) AS preciosoles,
                    T1.total,
                    (CASE
                        WHEN T4.idestado = '00001' THEN ROUND(T1.cantidad*T1.precio*(SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_CAMBIO' AND TT.codigo = '00001' AND TT.eliminado = 0 LIMIT 1),2) 
                        ELSE T1.totalsoles
                    END) AS totalsoles,
                    T2.descripcion AS dscmaterial
                FROM
                    proymaterial T1
                    INNER JOIN material T2 ON
                        T2.idmaterial = T1.idmaterial
                    INNER JOIN proyecto T3 ON
                        T3.idproyecto = T1.idproyecto
                    INNER JOIN cotizacion T4 ON
                        T4.idcotizacion = T3.idcotizacion
                WHERE
                    COALESCE(?,0) IN (T1.idproyecto,0)
                    AND COALESCE(?,0) IN (T1.idmaterial,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,6";
        
        $query = $this->db->query($sql, array($idProyecto, $idMaterial));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oProyMaterialBE = new ProyMaterialBE();

            $oProyMaterialBE->idProyecto = (int)$row->idproyecto;
            $oProyMaterialBE->idMaterial = (int)$row->idmaterial;
            $oProyMaterialBE->cantidad = (double)$row->cantidad;
            $oProyMaterialBE->precio = (double)$row->precio;
            $oProyMaterialBE->precioSoles = (double)$row->preciosoles;
            $oProyMaterialBE->total = (double)$row->total;
            $oProyMaterialBE->totalSoles = (double)$row->totalsoles;
            $oProyMaterialBE->dscMaterial = $row->dscmaterial;

            array_push($listResult, $oProyMaterialBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createProyMaterial($oProyMaterialBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idProyecto = $oProyMaterialBE->idProyecto;
        $idMaterial = $oProyMaterialBE->idMaterial;
        $cantidad = $oProyMaterialBE->cantidad;
        $precio = $oProyMaterialBE->precio;
        $precioSoles = $oProyMaterialBE->precioSoles;
        $total = $oProyMaterialBE->total;
        $totalSoles = $oProyMaterialBE->totalSoles;
        $idUsuCrea = $oProyMaterialBE->idUsuCrea;
                
        if ($idProyecto > 0 && $idMaterial > 0)
        {
            $sql = "INSERT INTO proymaterial
                    (
                        idproyecto,
                        idmaterial,
                        cantidad,
                        precio,
                        preciosoles,
                        total,
                        totalsoles,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    );";
                
            $query = $this->db->query($sql, array($idProyecto,
                                                  $idMaterial,
                                                  $cantidad,
                                                  $precio,
                                                  $precioSoles,
                                                  $total,
                                                  $totalSoles,
                                                  $idUsuCrea));

            if($query)
            {
                $oProyMaterialBE = new ProyMaterialBE();

                $oProyMaterialBE->idProyecto = $idProyecto;
                $oProyMaterialBE->idMaterial = $idMaterial;

                $listResult = $this->getProyMaterial($oProyMaterialBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Material de proyecto grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto y el codigo de Material";
        }

        return $objResult;
    }    

    public function deleteProyMaterial($oProyMaterialBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idProyecto = $oProyMaterialBE->idProyecto;                
        
        if ($idProyecto > 0)
        {            
            $sql = "DELETE FROM proymaterial WHERE idproyecto=?";
                
            $query = $this->db->query($sql, array($idProyecto));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Materiales de Proyecto eliminados correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }
}
?>