<?php

class ProyMovilizacionDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getProyMovilizacion($oProyMovilizacionBE, &$retorno, &$mensaje)
    {
        $idProyecto = $oProyMovilizacionBE->idProyecto;
        $semana = $oProyMovilizacionBE->semana;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idproyecto,
                    T1.semana,
                    T1.pasajes,
                    T1.alimentacion
                FROM
                    proymovilizacion T1
                WHERE
                    COALESCE(?,0) IN (T1.idproyecto,0)
                    AND COALESCE(?,0) IN (T1.semana,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,2";
        
        $query = $this->db->query($sql, array($idProyecto,$semana));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oProyMovilizacionBE = new ProyMovilizacionBE();

            $oProyMovilizacionBE->idProyecto = (int)$row->idproyecto;
            $oProyMovilizacionBE->semana = (int)$row->semana;
            $oProyMovilizacionBE->pasajes = (double)$row->pasajes;
            $oProyMovilizacionBE->alimentacion = (double)$row->alimentacion;

            array_push($listResult, $oProyMovilizacionBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createProyMovilizacion($oProyMovilizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idProyecto = $oProyMovilizacionBE->idProyecto;
        $semana = $oProyMovilizacionBE->semana;
        $pasajes = $oProyMovilizacionBE->pasajes;
        $alimentacion = $oProyMovilizacionBE->alimentacion;
        $idUsuCrea = $oProyMovilizacionBE->idUsuCrea;
                
        if ($idProyecto > 0)
        {
            $sql = "INSERT INTO proymovilizacion
                    (
                        idproyecto,
                        semana,
                        pasajes,
                        alimentacion,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,	
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idProyecto,
                                                  $semana,
                                                  $pasajes,
                                                  $alimentacion,
                                                  $idUsuCrea));

            if($query)
            {
                $oProyMovilizacionBE = new ProyMovilizacionBE();

                $oProyMovilizacionBE->idProyecto = $idProyecto;
                $oProyMovilizacionBE->semana = $semana;

                $listResult = $this->getProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Movilizacion de proyecto grabada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }    

    public function deleteProyMovilizacion($oProyMovilizacionBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idProyecto = $oProyMovilizacionBE->idProyecto;                
        
        if ($idProyecto > 0)
        {            
            $sql = "DELETE FROM proymovilizacion WHERE idproyecto=?";
                
            $query = $this->db->query($sql, array($idProyecto));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Movilizaciones de Proyecto eliminadas correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }
}
?>