<?php

class ProyOperarioDAO extends CI_Model 
{
    public function __construct()
    {    
        parent::__construct();
    }

    public function getProyOperario($oProyOperarioBE, &$retorno, &$mensaje)
    {
        $idProyecto = $oProyOperarioBE->idProyecto;
        $idOperario = $oProyOperarioBE->idOperario;

        $listResult = array();
              
        $sql = "SELECT
                    T1.idproyecto,
                    T1.idoperario,
                    DATE_FORMAT(T1.fecing, '%d/%m/%Y') AS fecing,
                    DATE_FORMAT(T1.fecegr, '%d/%m/%Y') AS fecegr,
                    T1.costo,
                    T1.total,
                    CONCAT(COALESCE(T2.nombres,''),' ',COALESCE(T2.apellidos,'')) AS nomoperario,
                    T2.numdoc AS numdocoperario,	
                    T2.especialidad AS especialidadoperario,
                    (SELECT TT.abreviatura FROM parametro TT WHERE TT.tipparam = 'TIPO_DOCUMENTO' AND TT.codigo = T2.idtipdoc AND TT.eliminado = 0 LIMIT 1) AS dsctipdocoperario
                FROM
                    proyoperario T1
                    INNER JOIN operario T2 ON
                        T2.idoperario = T1.idoperario
                WHERE
                    COALESCE(?,0) IN (T1.idproyecto,0)
                    AND COALESCE(?,0) IN (T1.idoperario,0)
                    AND T1.eliminado = 0
                ORDER BY
                    1,6";
        
        $query = $this->db->query($sql, array($idProyecto, $idOperario));

        if($query)
        {
          $list = $query->result();

          foreach ($list as $row)
          {
            $oProyOperarioBE = new ProyOperarioBE();

            $oProyOperarioBE->idProyecto = (int)$row->idproyecto;
            $oProyOperarioBE->idOperario = (int)$row->idoperario;
            $oProyOperarioBE->fecIng = $row->fecing;
            $oProyOperarioBE->fecEgr = $row->fecegr;
            $oProyOperarioBE->costo = (double)$row->costo;
            $oProyOperarioBE->total = (double)$row->total;
            $oProyOperarioBE->nomOperario = $row->nomoperario;
            $oProyOperarioBE->numDocOperario = $row->numdocoperario;
            $oProyOperarioBE->especialidadOperario = $row->especialidadoperario;
            $oProyOperarioBE->dscTipDocOperario = $row->dsctipdocoperario;

            array_push($listResult, $oProyOperarioBE);
          }
          
          $retorno = 0;
          $mensaje = MSG_OK_GENERAL;
        }
        else
        {
          $retorno = 1;
          $mensaje = MSG_ERROR_GENERAL;
        }

        return $listResult;
    }
    
    public function createProyOperario($oProyOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
                
        $idProyecto = $oProyOperarioBE->idProyecto;
        $idOperario = $oProyOperarioBE->idOperario;
        $fecIng = $oProyOperarioBE->fecIng;
        $fecEgr = $oProyOperarioBE->fecEgr;
        $costo = $oProyOperarioBE->costo;
        $total = $oProyOperarioBE->total;
        $idUsuCrea = $oProyOperarioBE->idUsuCrea;
                
        if ($idProyecto > 0 && $idOperario > 0)
        {
            $sql = "INSERT INTO proyoperario
                    (
                        idproyecto,
                        idoperario,
                        fecing,
                        fecegr,
                        costo,
                        total,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,                        
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idProyecto,
                                                  $idOperario,
                                                  $fecIng,
                                                  $fecEgr,
                                                  $costo,
                                                  $total,
                                                  $idUsuCrea));

            if($query)
            {
                $oProyOperarioBE = new ProyOperarioBE();

                $oProyOperarioBE->idProyecto = $idProyecto;
                $oProyOperarioBE->idOperario = $idOperario;

                $listResult = $this->getProyOperario($oProyOperarioBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Operario de proyecto grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }         
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto y el codigo de Operario";
        }

        return $objResult;
    }    

    public function deleteProyOperario($oProyOperarioBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idProyecto = $oProyOperarioBE->idProyecto;                
        
        if ($idProyecto > 0)
        {            
            $sql = "DELETE FROM proyoperario WHERE idproyecto=?";
                
            $query = $this->db->query($sql, array($idProyecto));

            if($query)
            {
                $retorno = 0;
                $mensaje = "Operarios de Proyecto eliminados correctamente";
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }
}
?>