<?php

class ProyectoDAO extends CI_Model 
{
	public function __construct()
	{		 
		parent::__construct();
    }

    public function getProyecto($oProyectoBE, &$retorno, &$mensaje)
	{
        $this->load->model('ProyMaterialDAO', 'proyMaterialDAO');
        $this->load->model('ProyOperarioDAO', 'proyOperarioDAO');
        $this->load->model('ProyMovilizacionDAO', 'proyMovilizacionDAO');
        $this->load->model('ProyCostoDAO', 'proyCostoDAO');
        $this->load->model('ProveedorDAO', 'proveedorDAO');
        $this->load->model('ClienteDAO', 'clienteDAO');

        $idProyecto = $oProyectoBE->idProyecto;
        $idCotizacion = $oProyectoBE->idCotizacion;
        $idProveedor = $oProyectoBE->idProveedor;
        $idCliente = $oProyectoBE->idCliente;
        $idTipProy = $oProyectoBE->idTipProy;        
        $numero = $oProyectoBE->numero;
        $orden = $oProyectoBE->orden;
        $nomProy = $oProyectoBE->nomProy;        

		$listResult = array();
		
        $sql = "SELECT
                    T1.idproyecto,
                    T1.idcotizacion,
                    T1.idproveedor,
                    T1.idcliente,
                    T1.idtipproy,
                    T1.idmoneda,
                    T1.idestado,
                    T1.numero,
                    T1.nomproy,
                    T1.orden,
                    T1.responsable,
                    DATE_FORMAT(T1.feccotizacion, '%d/%m/%Y') AS feccotizacion,
                    DATE_FORMAT(T1.fecemision, '%d/%m/%Y') AS fecemision,
                    DATE_FORMAT(T1.fecinicio, '%d/%m/%Y') AS fecinicio,
                    DATE_FORMAT(T1.fecfin, '%d/%m/%Y') AS fecfin,
                    T1.valoferta,
                    T1.glosa,
                    T1.subtotal,
                    T1.igv,
                    T1.descuento,
                    T1.total,                    
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'TIPO_PROYECTO' AND TT.codigo = T1.idtipproy AND TT.eliminado = 0 LIMIT 1) AS dsctipproy,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'MONEDA' AND TT.codigo = T1.idmoneda AND TT.eliminado = 0 LIMIT 1) AS dscmoneda,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'ESTADO_COTIZACION' AND TT.codigo = T1.idestado AND TT.eliminado = 0 LIMIT 1) AS dscestado	
                FROM
                    proyecto T1
                    INNER JOIN cotizacion T2 ON
                        T2.idcotizacion = T1.idcotizacion
                    INNER JOIN proveedor T3 ON
                        T3.idproveedor = T1.idproveedor
                    INNER JOIN cliente T4 ON
                        T4.idcliente = T1.idcliente
                WHERE
                    COALESCE(?,0) IN (T1.idproyecto,0)
                    AND COALESCE(?,0) IN (T1.idcotizacion,0)
                    AND COALESCE(?,0) IN (T1.idproveedor,0)
                    AND COALESCE(?,0) IN (T1.idcliente,0)
                    AND COALESCE(?,'') IN (T1.idtipproy,'')
                    AND COALESCE(?,'') IN (T1.numero,'')
                    AND COALESCE(?,'') IN (T1.orden,'')
                    AND UPPER(COALESCE(T1.nomproy,'')) LIKE CONCAT('%',UPPER(COALESCE(?,'')),'%')
                    AND T1.eliminado = 0
                    AND T2.eliminado = 0
                    AND T3.eliminado = 0
                    AND T4.eliminado = 0";
		
        $query = $this->db->query($sql, array($idProyecto,
                                              $idCotizacion,
                                              $idProveedor,
                                              $idCliente,
                                              $idTipProy,                                              
                                              $numero,
                                              $orden,
                                              $nomProy));

		if($query)
		{
			$list = $query->result();

			foreach ($list as $row)
			{
				$oProyectoBE = new ProyectoBE();
                $oProyMaterialBE = new ProyMaterialBE();
                $oProyOperarioBE = new ProyOperarioBE();
                $oProyMovilizacionBE = new ProyMovilizacionBE();
                $oProyCostoBE = new ProyCostoBE();
                $oProveedorBE = new ProveedorBE();
                $oClienteBE = new ClienteBE();
                
                $oProyectoBE->idProyecto = (int)$row->idproyecto;
                $oProyectoBE->idCotizacion = (int)$row->idcotizacion;
                $oProyectoBE->idProveedor = (int)$row->idproveedor;
                $oProyectoBE->idCliente = (int)$row->idcliente;
                $oProyectoBE->idTipProy = $row->idtipproy;
                $oProyectoBE->idMoneda = $row->idmoneda;
                $oProyectoBE->idEstado = $row->idestado;
                $oProyectoBE->numero = $row->numero;
                $oProyectoBE->nomProy = $row->nomproy;
                $oProyectoBE->orden = $row->orden;
                $oProyectoBE->responsable = $row->responsable;                
                $oProyectoBE->fecCotizacion = $row->feccotizacion;
                $oProyectoBE->fecEmision = $row->fecemision;
                $oProyectoBE->fecInicio = $row->fecinicio;
                $oProyectoBE->fecFin = $row->fecfin;
                $oProyectoBE->valOferta = $row->valoferta;
                $oProyectoBE->glosa = $row->glosa;
                $oProyectoBE->subTotal = (double)$row->subtotal;
                $oProyectoBE->igv = (double)$row->igv;
                $oProyectoBE->descuento = (double)$row->descuento;
                $oProyectoBE->total = (double)$row->total;
                $oProyectoBE->dscTipProy = $row->dsctipproy;
                $oProyectoBE->dscMoneda = $row->dscmoneda;
                $oProyectoBE->dscEstado = $row->dscestado;

                $oProyMaterialBE->idProyecto = $oProyectoBE->idProyecto;
                $oProyOperarioBE->idProyecto = $oProyectoBE->idProyecto;
                $oProyMovilizacionBE->idProyecto = $oProyectoBE->idProyecto;
                $oProyCostoBE->idProyecto = $oProyectoBE->idProyecto;
                $oProveedorBE->idProveedor = $oProyectoBE->idProveedor;
                $oClienteBE->idCliente = $oProyectoBE->idCliente;

                $oProyectoBE->listProyMaterial = $this->proyMaterialDAO->getProyMaterial($oProyMaterialBE, $retorno, $mensaje);
                $oProyectoBE->listProyOperario = $this->proyOperarioDAO->getProyOperario($oProyOperarioBE, $retorno, $mensaje);
                $oProyectoBE->listProyMovilizacion = $this->proyMovilizacionDAO->getProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);
                $oProyectoBE->listProyCosto = $this->proyCostoDAO->getProyCosto($oProyCostoBE, $retorno, $mensaje);
                $oProyectoBE->proveedor = $this->proveedorDAO->getProveedor($oProveedorBE, $retorno, $mensaje)[0];
                $oProyectoBE->cliente = $this->clienteDAO->getCliente($oClienteBE, $retorno, $mensaje)[0];

				array_push($listResult, $oProyectoBE);
			}
			
			$retorno = 0;
			$mensaje = MSG_OK_GENERAL;
		}
		else
		{
			$retorno = 1;
			$mensaje = MSG_ERROR_GENERAL;
		}

		return $listResult;
    }
    
    public function createProyecto($oProyectoBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');
        $this->load->model('ProyMaterialDAO', 'proyMaterialDAO');
        $this->load->model('ProyOperarioDAO', 'proyOperarioDAO');
        $this->load->model('ProyMovilizacionDAO', 'proyMovilizacionDAO');
        $this->load->model('ProyCostoDAO', 'proyCostoDAO');

        $objResult = null;                

        $idCotizacion = $oProyectoBE->idCotizacion;
        $idProveedor = $oProyectoBE->idProveedor;
        $idCliente = $oProyectoBE->idCliente;
        $idTipProy = $oProyectoBE->idTipProy;
        $idMoneda = $oProyectoBE->idMoneda;
        $idEstado = $oProyectoBE->idEstado;
        $numero = $oProyectoBE->numero;
        $nomProy = $oProyectoBE->nomProy;
        $orden = $oProyectoBE->orden;
        $responsable = $oProyectoBE->responsable;
        $fecCotizacion = $oProyectoBE->fecCotizacion;
        $fecEmision = $oProyectoBE->fecEmision;
        $fecInicio = $oProyectoBE->fecInicio;
        $fecFin = $oProyectoBE->fecFin;
        $valOferta = $oProyectoBE->valOferta;
        $glosa = $oProyectoBE->glosa;
        $subTotal = $oProyectoBE->subTotal;
        $igv = $oProyectoBE->igv;
        $descuento = $oProyectoBE->descuento;
        $total = $oProyectoBE->total;
        $idUsuCrea = $oProyectoBE->idUsuCrea;

        $listProyMaterial = $oProyectoBE->listProyMaterial;
        $listProyOperario = $oProyectoBE->listProyOperario;
        $listProyMovilizacion = $oProyectoBE->listProyMovilizacion;
        $listProyCosto = $oProyectoBE->listProyCosto;                                

        $idProyecto = $this->util->getNextId("proyecto","idproyecto");
        
        if ($idProyecto > 0)
        {
            $sql = "INSERT INTO proyecto
                    (
                        idproyecto,
                        idcotizacion,
                        idproveedor,
                        idcliente,
                        idtipproy,
                        idmoneda,
                        idestado,
                        numero,
                        nomproy,
                        orden,
                        responsable,
                        feccotizacion,
                        fecemision,
                        fecinicio,
                        fecfin,
                        valoferta,
                        glosa,
                        subtotal,
                        igv,
                        descuento,
                        total,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idProyecto,
                                                  $idCotizacion,
                                                  $idProveedor,
                                                  $idCliente,
                                                  $idTipProy,
                                                  $idMoneda,
                                                  $idEstado,
                                                  $numero,
                                                  $nomProy,
                                                  $orden,
                                                  $responsable,
                                                  $fecCotizacion,
                                                  $fecEmision,
                                                  $fecInicio,
                                                  $fecFin,
                                                  $valOferta,
                                                  $glosa,
                                                  $subTotal,
                                                  $igv,
                                                  $descuento,
                                                  $total,
                                                  $idUsuCrea));

            if($query)
            {
                if ($listProyMaterial != null && count($listProyMaterial) > 0)
                {    
                    $oProyMaterialBE = new ProyMaterialBE();

                    $oProyMaterialBE->idProyecto = $idProyecto;

                    $obj = $this->proyMaterialDAO->deleteProyMaterial($oProyMaterialBE, $retorno, $mensaje);

                    foreach ($listProyMaterial as $row)
                    {
                        $oProyMaterialBE = new ProyMaterialBE();

                        $oProyMaterialBE->idProyecto = $idProyecto;
                        $oProyMaterialBE->idMaterial = $row['idMaterial'];
                        $oProyMaterialBE->cantidad = $row['cantidad'];
                        $oProyMaterialBE->precio = $row['precio'];
                        $oProyMaterialBE->precioSoles = $row['precioSoles'];
                        $oProyMaterialBE->total = $row['total'];
                        $oProyMaterialBE->totalSoles = $row['totalSoles'];
                        $oProyMaterialBE->idUsuCrea = $idUsuCrea;                        

                        $obj = $this->proyMaterialDAO->createProyMaterial($oProyMaterialBE, $retorno, $mensaje);
                    }
                }

                if ($listProyOperario != null && count($listProyOperario) > 0)
                {    
                    $oProyOperarioBE = new ProyOperarioBE();

                    $oProyOperarioBE->idProyecto = $idProyecto;

                    $obj = $this->proyOperarioDAO->deleteProyOperario($oProyOperarioBE, $retorno, $mensaje);

                    foreach ($listProyOperario as $row)
                    {
                        $oProyOperarioBE = new ProyOperarioBE();

                        $oProyOperarioBE->idProyecto = $idProyecto;
                        $oProyOperarioBE->idOperario = $row['idOperario'];
                        $oProyOperarioBE->fecIng = $row['fecIng'];
                        $oProyOperarioBE->fecEgr = $row['fecEgr'];
                        $oProyOperarioBE->costo = $row['costo'];
                        $oProyOperarioBE->total = $row['total'];
                        $oProyOperarioBE->idUsuCrea = $idUsuCrea;

                        $obj = $this->proyOperarioDAO->createProyOperario($oProyOperarioBE, $retorno, $mensaje);
                    }
                }

                if ($listProyMovilizacion != null && count($listProyMovilizacion) > 0)
                {    
                    $oProyMovilizacionBE = new ProyMovilizacionBE();

                    $oProyMovilizacionBE->idProyecto = $idProyecto;

                    $obj = $this->proyMovilizacionDAO->deleteProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);

                    foreach ($listProyMovilizacion as $row)
                    {
                        $oProyMovilizacionBE = new ProyMovilizacionBE();

                        $oProyMovilizacionBE->idProyecto = $idProyecto;
                        $oProyMovilizacionBE->semana = $row['semana'];
                        $oProyMovilizacionBE->pasajes = $row['pasajes'];
                        $oProyMovilizacionBE->alimentacion = $row['alimentacion'];                        
                        $oProyMovilizacionBE->idUsuCrea = $idUsuCrea;

                        $obj = $this->proyMovilizacionDAO->createProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);
                    }
                }

                if ($listProyCosto != null && count($listProyCosto) > 0)
                {    
                    $oProyCostoBE = new ProyCostoBE();

                    $oProyCostoBE->idProyecto = $idProyecto;

                    $obj = $this->proyCostoDAO->deleteProyCosto($oProyCostoBE, $retorno, $mensaje);

                    foreach ($listProyCosto as $row)
                    {
                        $oProyCostoBE = new ProyCostoBE();

                        $oProyCostoBE->idProyecto = $idProyecto;
                        $oProyCostoBE->titulo = $row['titulo'];
                        $oProyCostoBE->descripcion = $row['descripcion'];
                        $oProyCostoBE->fecha = $row['fecha'];
                        $oProyCostoBE->valor = $row['valor'];
                        $oProyCostoBE->idUsuCrea = $idUsuCrea;

                        $obj = $this->proyCostoDAO->createProyCosto($oProyCostoBE, $retorno, $mensaje);
                    }
                }

                $oProyectoBE = new ProyectoBE();

                $oProyectoBE->idProyecto = $idProyecto;

                $listResult = $this->getProyecto($oProyectoBE, $retorno, $mensaje);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $retorno = 0;
                    $mensaje = "Proyecto grabado correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Ocurrió un error al obtener el codigo de Proyecto";
        }
        

        return $objResult;
    }

    public function updateProyecto($oProyectoBE, &$retorno, &$mensaje)
    {
        $this->load->model('UtilDAO', 'util');
        $this->load->model('ProyMaterialDAO', 'proyMaterialDAO');
        $this->load->model('ProyOperarioDAO', 'proyOperarioDAO');
        $this->load->model('ProyMovilizacionDAO', 'proyMovilizacionDAO');
        $this->load->model('ProyCostoDAO', 'proyCostoDAO');

        $objResult = null;

        $idProyecto = $oProyectoBE->idProyecto;
        $idCotizacion = $oProyectoBE->idCotizacion;
        $idProveedor = $oProyectoBE->idProveedor;
        $idCliente = $oProyectoBE->idCliente;
        $idTipProy = $oProyectoBE->idTipProy;
        $idMoneda = $oProyectoBE->idMoneda;
        $idEstado = $oProyectoBE->idEstado;
        $numero = $oProyectoBE->numero;
        $nomProy = $oProyectoBE->nomProy;
        $orden = $oProyectoBE->orden;
        $responsable = $oProyectoBE->responsable;
        $fecCotizacion = $oProyectoBE->fecCotizacion;
        $fecEmision = $oProyectoBE->fecEmision;
        $fecInicio = $oProyectoBE->fecInicio;
        $fecFin = $oProyectoBE->fecFin;
        $valOferta = $oProyectoBE->valOferta;
        $glosa = $oProyectoBE->glosa;
        $subTotal = $oProyectoBE->subTotal;
        $igv = $oProyectoBE->igv;
        $descuento = $oProyectoBE->descuento;
        $total = $oProyectoBE->total;
        $idUsuMod = $oProyectoBE->idUsuMod;

        $listProyMaterial = $oProyectoBE->listProyMaterial;
        $listProyOperario = $oProyectoBE->listProyOperario;
        $listProyMovilizacion = $oProyectoBE->listProyMovilizacion;
        $listProyCosto = $oProyectoBE->listProyCosto;
        
        if ($idProyecto > 0)
        {
            $oProyectoBE = new ProyectoBE();

            $oProyectoBE->idProyecto = $idProyecto;

            $listResult = $this->getProyecto($oProyectoBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {
                $sql = "UPDATE 
                            proyecto
                        SET
                            idcotizacion = COALESCE(?,idcotizacion),
                            idproveedor = COALESCE(?,idproveedor),
                            idcliente = COALESCE(?,idcliente),
                            idtipproy = COALESCE(?,idtipproy),
                            idmoneda = COALESCE(?,idmoneda),
                            idestado = COALESCE(?,idestado),
                            numero = COALESCE(?,numero),
                            nomproy = COALESCE(?,nomproy),
                            orden = COALESCE(?,orden),
                            responsable = COALESCE(?,responsable),
                            feccotizacion = COALESCE(?,feccotizacion),
                            fecemision = COALESCE(?,fecemision),
                            fecinicio = COALESCE(?,fecinicio),
                            fecfin = COALESCE(?,fecfin),
                            valoferta = COALESCE(?,valoferta),
                            glosa = COALESCE(?,glosa),
                            subtotal = COALESCE(?,subtotal),
                            igv = COALESCE(?,igv),
                            descuento = COALESCE(?,descuento),
                            total = COALESCE(?,total),
                            idusumod = COALESCE(?,idusumod),
                            fecusumod = NOW()
                        WHERE
                            idproyecto = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idCotizacion,
                                                      $idProveedor,
                                                      $idCliente,
                                                      $idTipProy,
                                                      $idMoneda,
                                                      $idEstado,
                                                      $numero,
                                                      $nomProy,
                                                      $orden,
                                                      $responsable,
                                                      $fecCotizacion,
                                                      $fecEmision,
                                                      $fecInicio,
                                                      $fecFin,
                                                      $valOferta,
                                                      $glosa,
                                                      $subTotal,
                                                      $igv,
                                                      $descuento,
                                                      $total,                                                      
                                                      $idUsuMod,                
                                                      $idProyecto));

                if($query)
                {
                    if ($listProyMaterial != null && count($listProyMaterial) > 0)
                    {    
                        $oProyMaterialBE = new ProyMaterialBE();

                        $oProyMaterialBE->idProyecto = $idProyecto;

                        $obj = $this->proyMaterialDAO->deleteProyMaterial($oProyMaterialBE, $retorno, $mensaje);

                        foreach ($listProyMaterial as $row)
                        {
                            $oProyMaterialBE = new ProyMaterialBE();

                            $oProyMaterialBE->idProyecto = $idProyecto;
                            $oProyMaterialBE->idMaterial = $row['idMaterial'];
                            $oProyMaterialBE->cantidad = $row['cantidad'];
                            $oProyMaterialBE->precio = $row['precio'];
                            $oProyMaterialBE->precioSoles = $row['precioSoles'];
                            $oProyMaterialBE->total = $row['total'];
                            $oProyMaterialBE->totalSoles = $row['totalSoles'];
                            $oProyMaterialBE->idUsuCrea = $idUsuMod;

                            $obj = $this->proyMaterialDAO->createProyMaterial($oProyMaterialBE, $retorno, $mensaje);
                        }
                    }

                    if ($listProyOperario != null && count($listProyOperario) > 0)
                    {    
                        $oProyOperarioBE = new ProyOperarioBE();

                        $oProyOperarioBE->idProyecto = $idProyecto;

                        $obj = $this->proyOperarioDAO->deleteProyOperario($oProyOperarioBE, $retorno, $mensaje);

                        foreach ($listProyOperario as $row)
                        {
                            $oProyOperarioBE = new ProyOperarioBE();

                            $oProyOperarioBE->idProyecto = $idProyecto;
                            $oProyOperarioBE->idOperario = $row['idOperario'];
                            $oProyOperarioBE->fecIng = $row['fecIng'];
                            $oProyOperarioBE->fecEgr = $row['fecEgr'];
                            $oProyOperarioBE->costo = $row['costo'];
                            $oProyOperarioBE->total = $row['total'];
                            $oProyOperarioBE->idUsuCrea = $idUsuMod;

                            $obj = $this->proyOperarioDAO->createProyOperario($oProyOperarioBE, $retorno, $mensaje);
                        }
                    }

                    if ($listProyMovilizacion != null && count($listProyMovilizacion) > 0)
                    {    
                        $oProyMovilizacionBE = new ProyMovilizacionBE();

                        $oProyMovilizacionBE->idProyecto = $idProyecto;

                        $obj = $this->proyMovilizacionDAO->deleteProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);

                        foreach ($listProyMovilizacion as $row)
                        {
                            $oProyMovilizacionBE = new ProyMovilizacionBE();

                            $oProyMovilizacionBE->idProyecto = $idProyecto;
                            $oProyMovilizacionBE->semana = $row['semana'];
                            $oProyMovilizacionBE->pasajes = $row['pasajes'];
                            $oProyMovilizacionBE->alimentacion = $row['alimentacion'];                        
                            $oProyMovilizacionBE->idUsuCrea = $idUsuMod;

                            $obj = $this->proyMovilizacionDAO->createProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);
                        }
                    }

                    if ($listProyCosto != null && count($listProyCosto) > 0)
                    {    
                        $oProyCostoBE = new ProyCostoBE();

                        $oProyCostoBE->idProyecto = $idProyecto;

                        $obj = $this->proyCostoDAO->deleteProyCosto($oProyCostoBE, $retorno, $mensaje);

                        foreach ($listProyCosto as $row)
                        {
                            $oProyCostoBE = new ProyCostoBE();

                            $oProyCostoBE->idProyecto = $idProyecto;
                            $oProyCostoBE->titulo = $row['titulo'];
                            $oProyCostoBE->descripcion = $row['descripcion'];
                            $oProyCostoBE->fecha = $row['fecha'];
                            $oProyCostoBE->valor = $row['valor'];
                            $oProyCostoBE->idUsuCrea = $idUsuMod;

                            $obj = $this->proyCostoDAO->createProyCosto($oProyCostoBE, $retorno, $mensaje);
                        }
                    }

                    $oProyectoBE = new ProyectoBE();

                    $oProyectoBE->idProyecto = $idProyecto;

                    $listResult = $this->getProyecto($oProyectoBE, $retorno, $mensaje);

                    if(count($listResult) > 0)
                    {
                        $objResult = $listResult[0];

                        $retorno = 0;
                        $mensaje = "Proyecto Grabado Correctamente";
                    }
                    else
                    {
                        $retorno = 1;
                        $mensaje = MSG_ERROR_GENERAL;
                    }
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "El Proyecto no Existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe Ingresar el Codigo de Proyecto";
        }

        return $objResult;        
    }

    public function deleteProyecto($oProyectoBE, &$retorno, &$mensaje)
    {
        $this->load->model('ProyMaterialDAO', 'proyMaterialDAO');
        $this->load->model('ProyOperarioDAO', 'proyOperarioDAO');
        $this->load->model('ProyMovilizacionDAO', 'proyMovilizacionDAO');
        $this->load->model('ProyCostoDAO', 'proyCostoDAO');

        $objResult = null;

        $idProyecto = $oProyectoBE->idProyecto;
        $idUsuMod = $oProyectoBE->idUsuMod;
        
        if ($idProyecto > 0)
        {                                
            $oProyectoBE = new ProyectoBE();

            $oProyectoBE->idProyecto = $idProyecto;

            $listResult = $this->getProyecto($oProyectoBE, $retorno, $mensaje);

            if(count($listResult) > 0)
            {                
                $sql = "UPDATE 
                            proyecto
                        SET
                            idusumod = ?,
                            fecusumod = NOW(),
                            eliminado = 1
                        WHERE
                            idproyecto = ?
                            AND eliminado = 0";
                    
                $query = $this->db->query($sql, array($idUsuMod, $idProyecto));

                if($query)
                {
                    $oProyMaterialBE = new ProyMaterialBE();
                    $oProyOperarioBE = new ProyOperarioBE();
                    $oProyMovilizacionBE = new ProyMovilizacionBE();
                    $oProyCostoBE = new ProyCostoBE();

                    $oProyMaterialBE->idProyecto = $idProyecto;
                    $oProyOperarioBE->idProyecto = $idProyecto;
                    $oProyMovilizacionBE->idProyecto = $idProyecto;
                    $oProyCostoBE->idProyecto = $idProyecto;

                    $obj = $this->proyMaterialDAO->deleteProyMaterial($oProyMaterialBE, $retorno, $mensaje);
                    $obj = $this->proyOperarioDAO->deleteProyOperario($oProyOperarioBE, $retorno, $mensaje);
                    $obj = $this->proyMovilizacionDAO->deleteProyMovilizacion($oProyMovilizacionBE, $retorno, $mensaje);
                    $obj = $this->proyCostoDAO->deleteProyCosto($oProyCostoBE, $retorno, $mensaje);

                    $retorno = 0;
                    $mensaje = "Proyecto eliminada correctamente";
                }
                else
                {
                    $retorno = 1;
                    $mensaje = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $retorno = 1;
                $mensaje = "La Proyecto no existe";
            }
        }
        else
        {
            $retorno = 1;
            $mensaje = "Debe ingresar el codigo de Proyecto";
        }

        return $objResult;
    }    
}
?>