<?php

class UsuarioDAO extends CI_Model 
{
	public function __construct()
	{		 
		parent::__construct();
    }        

    public function getUsuario($oUsuarioBE, &$return, &$message)
	{				
		$idUsuario = $oUsuarioBE->idUsuario;
        $login = $oUsuarioBE->login;
        $clave = $oUsuarioBE->clave;

		$listResult = array();
					
        $sql = "SELECT
                    T1.idusuario,
                    T1.idperfil,
                    T1.idsexo,
                    T1.nombres,
                    T1.apellidos,
                    T1.telefono,
                    T1.email,
                    T1.login,
                    T1.clave,
                    T1.foto,                    
                    T1.observacion,
                    (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'SEXO' AND TT.codigo = T1.idsexo LIMIT 1) AS dscsexo,
                    CONCAT('".RUTA_FOTO_USUARIO."',T1.foto,'?',DATE_FORMAT(UTC_TIMESTAMP(), '%s%m%H%Y%d%i')) AS fotourl,
                    T2.nombre AS dscperfil
                FROM
                    usuario T1
                    INNER JOIN perfil T2 ON
                        T2.idperfil = T1.idperfil
                WHERE
                    COALESCE(?,0) IN (T1.idusuario,0)
                    AND COALESCE(?,'') IN (T1.login,'')
                    AND COALESCE(?,'') IN (T1.clave,'')
                    AND T1.eliminado = 0
                ORDER BY
                    4";
		
		$query = $this->db->query($sql, array($idUsuario, $login, $clave));

		if($query)
		{
			$list = $query->result();

			foreach ($list as $row)
			{
				$oUsuarioBE = new UsuarioBE();

				$oUsuarioBE->idUsuario = (int)$row->idusuario;
                $oUsuarioBE->idPerfil = (int)$row->idperfil;
                $oUsuarioBE->idSexo = $row->idsexo;
                $oUsuarioBE->nombres = $row->nombres;
                $oUsuarioBE->apellidos = $row->apellidos;
                $oUsuarioBE->telefono = $row->telefono;
                $oUsuarioBE->email = $row->email;
                $oUsuarioBE->login = $row->login;
                $oUsuarioBE->clave = $row->clave;
                $oUsuarioBE->foto = $row->foto;                
                $oUsuarioBE->observacion = $row->observacion;
                $oUsuarioBE->dscSexo = $row->dscsexo;
                $oUsuarioBE->fotoURL = $row->fotourl;
                $oUsuarioBE->dscPerfil = $row->dscperfil;

				array_push($listResult, $oUsuarioBE);
			}
			
			$return = 0;
			$message = MSG_OK_GENERAL;
		}
		else
		{
			$return = 1;
			$message = MSG_ERROR_GENERAL;
		}

		return $listResult;
    }
    
    public function createUsuario($oUsuarioBE, &$return, &$message)
	{
        $this->load->model('UtilDAO', 'util');

        $objResult = null;
        
        $nombres = $oUsuarioBE->nombres;
        $idPerfil = $oUsuarioBE->idPerfil;
        $apellidos = $oUsuarioBE->apellidos;
        $telefono = $oUsuarioBE->telefono;
        $email = $oUsuarioBE->email;
        $login = $oUsuarioBE->login;
        $clave = $oUsuarioBE->clave;
        $fotoBase64 = $oUsuarioBE->fotoBase64;
        $idSexo = $oUsuarioBE->idSexo;
        $observacion = $oUsuarioBE->observacion;
        $idUsuCrea = $oUsuarioBE->idUsuCrea;

        if($this->util->existData("usuario", "login", $login, "idusuario", 0, "eliminado"))
        {
            $return = 1;
            $message = "El Login ya existe";

            return 0;
        }
        
        if($this->util->existData("usuario", "email", $email, "idusuario", 0, "eliminado"))
        {
            $return = 1;
            $message = "El Email ya existe";

            return 0;
        }

        $idUsuario = $this->util->getNextId("usuario","idusuario");        
        
        if($fotoBase64 != null)
        {
            $image = base64_decode($fotoBase64);
            $filename = 'FotoUsuario_'.$idUsuario.'.'.'jpg';
            $path = PATH_FOTO_USUARIO;

            file_put_contents($path.$filename, $image);

            $foto = $filename;
        }
        else
        {
            $foto = NAME_FOTO_DEFAULT;
        }        

        if ($idUsuario > 0)
        {            
            $sql = "INSERT INTO usuario
                    (
                        idusuario,
                        idperfil,
                        idsexo,
                        nombres,
                        apellidos,
                        telefono,
                        email,
                        login,
                        clave,
                        foto,                        
                        observacion,
                        idusucrea,
                        fecusucrea,
                        idusumod,
                        fecusumod,
                        eliminado
                    )
                    VALUES
                    (
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        NOW(),
                        NULL,
                        NULL,
                        0
                    )";
                
            $query = $this->db->query($sql, array($idUsuario,
                                                  $idPerfil,
                                                  $idSexo,
                                                  $nombres,
                                                  $apellidos,
                                                  $telefono,
                                                  $email,
                                                  $login,
                                                  $clave,
                                                  $foto,                                                  
                                                  $observacion,
                                                  $idUsuCrea));

            if($query)
            {
                $oUsuarioBE = new UsuarioBE();

                $oUsuarioBE->idUsuario = $idUsuario;

                $listResult = $this->getUsuario($oUsuarioBE, $return, $message);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $return = 0;
                    $message = "Usuario Grabado Correctamente";
                }
                else
                {
                    $return = 1;
                    $message = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $return = 1;
                $message = MSG_ERROR_GENERAL;
            }        	
        }
        else
        {
            $return = 1;
            $message = MSG_ERROR_GENERAL;
        }

		return $objResult;
    }

    public function updateUsuario($oUsuarioBE, &$return, &$message)
    {
        $this->load->model('UtilDAO', 'util');

        $objResult = null;                

        $idUsuario = $oUsuarioBE->idUsuario;
        $idPerfil = $oUsuarioBE->idPerfil;
        $idSexo = $oUsuarioBE->idSexo;
        $nombres = $oUsuarioBE->nombres;
        $apellidos = $oUsuarioBE->apellidos;
        $telefono = $oUsuarioBE->telefono;
        $email = $oUsuarioBE->email;
        $login = $oUsuarioBE->login;
        $clave = $oUsuarioBE->clave;
        $fotoBase64 = $oUsuarioBE->fotoBase64;        
        $observacion = $oUsuarioBE->observacion;        
        $idUsuMod = $oUsuarioBE->idUsuMod;        
        $eliminado = $oUsuarioBE->eliminado;
        $foto = null;
        
        if($fotoBase64 != null)
        {
            $image = base64_decode($fotoBase64);
            $filename = 'FotoUsuario_'.$idUsuario.'.'.'jpg';
            $path = PATH_FOTO_USUARIO;

            file_put_contents($path.$filename, $image);

            $foto = $filename;
        }
        
        if($this->util->existData("usuario", "login", $login, "idusuario", $idUsuario, "eliminado"))
        {
            $return = 1;
            $message = "El Login ya existe";

            return 0;
        }
        
        if($this->util->existData("usuario", "email", $email, "idusuario", $idUsuario, "eliminado"))
        {
            $return = 1;
            $message = "El Email ya existe";

            return 0;
        }        
        
        if ($idUsuario > 0)
        {            
            $sql = "UPDATE 
                        usuario
                    SET                        
                        idperfil = COALESCE(?,idperfil),
                        idsexo = COALESCE(?,idsexo),
                        nombres = COALESCE(?,nombres),                        
                        apellidos = COALESCE(?,apellidos),
                        telefono = COALESCE(?,telefono),
                        email = COALESCE(?,email),
                        login = COALESCE(?,login),
                        clave = COALESCE(?,clave),
                        foto = COALESCE(?,foto),                        
                        observacion = COALESCE(?,observacion),                        
                        idusumod = COALESCE(?,idusumod),
                        fecusumod = NOW(),
                        eliminado = COALESCE(?,eliminado)
                    WHERE
                        idusuario = ?
                        AND eliminado = 0";
                
            $query = $this->db->query($sql, array($idPerfil,
                                                  $idSexo,
                                                  $nombres,
                                                  $apellidos,
                                                  $telefono,
                                                  $email,
                                                  $login,
                                                  $clave,
                                                  $foto,                                                  
                                                  $observacion,                                                  
                                                  $idUsuMod,                                                  
                                                  $eliminado,
                                                  $idUsuario));
            if($query)
            {
                $oUsuarioBE = new UsuarioBE();

                $oUsuarioBE->idUsuario = $idUsuario;

                $listResult = $this->getUsuario($oUsuarioBE, $return, $message);

                if(count($listResult) > 0)
                {
                    $objResult = $listResult[0];

                    $return = 0;
                    $message = "Usuario Grabado Correctamente";
                }
                else
                {
                    $return = 1;
                    $message = MSG_ERROR_GENERAL;
                }
            }
            else
            {
                $return = 1;
                $message = MSG_ERROR_GENERAL;
            }           
        }
        else
        {
            $return = 1;
            $message = MSG_ERROR_GENERAL;
        }

        return $objResult;
    }

    public function deleteUsuario($oUsuarioBE, &$return, &$message)
    {        
        $objResult = null;

        $idUsuario = $oUsuarioBE->idUsuario;        
        
        if ($idUsuario > 0)
        {            
            $sql = "UPDATE 
                        usuario
                    SET                                                
                        eliminado = 1
                    WHERE
                        idusuario = ?
                        AND eliminado = 0";
                
            $query = $this->db->query($sql, array($idUsuario));

            if($query)
            {
                $return = 0;
                $message = MSG_OK_GENERAL;
            }
            else
            {
                $return = 1;
                $message = MSG_ERROR_GENERAL;
            }
        }
        else
        {
            $return = 1;
            $message = MSG_ERROR_GENERAL;
        }

        return $objResult;
    }

    public function authenticateUsuario($oUsuarioBE, &$return, &$message)
    {
        $login = $oUsuarioBE->login;
        $clave = $oUsuarioBE->clave;

        $objResult = new UsuarioBE();

        $sql = "SELECT * FROM usuario WHERE login = COALESCE(?,'') AND eliminado = 0";

        $query = $this->db->query($sql, array($login));

        if($query)
        {
            $data = $query->row();

            if (isset($data))
            {                
                $sql = "SELECT
                            T1.idusuario,
                            T1.idperfil,
                            T1.idsexo,
                            T1.nombres,
                            T1.apellidos,
                            T1.telefono,
                            T1.email,
                            T1.login,
                            T1.clave,
                            T1.foto,                            
                            T1.observacion,
                            (SELECT TT.descripcion FROM parametro TT WHERE TT.tipparam = 'SEXO' AND TT.codigo = T1.idsexo LIMIT 1) AS dscsexo,
                            CONCAT('".RUTA_FOTO_USUARIO."',T1.foto,'?',DATE_FORMAT(UTC_TIMESTAMP(), '%s%m%H%Y%d%i')) AS fotourl,
                            T2.nombre AS dscperfil
                        FROM
                            usuario T1
                            INNER JOIN perfil T2 ON
                                T2.idperfil = T1.idperfil
                        WHERE
                            T1.login = ?
                            AND T1.clave = ?                            
                            AND T1.eliminado = 0";
        
                $query = $this->db->query($sql, array($login, $clave));
               
                $row = $query->row();

                if (isset($row))
                {                    
                    $objResult->idUsuario = (int)$row->idusuario;
                    $objResult->idPerfil = (int)$row->idperfil;
                    $objResult->idSexo = $row->idsexo;
                    $objResult->nombres = $row->nombres;
                    $objResult->apellidos = $row->apellidos;
                    $objResult->telefono = $row->telefono;
                    $objResult->email = $row->email;
                    $objResult->login = $row->login;
                    $objResult->clave = $row->clave;
                    $objResult->foto = $row->foto;                    
                    $objResult->observacion = $row->observacion;
                    $objResult->dscSexo = $row->dscsexo;
                    $objResult->fotoURL = $row->fotourl;
                    $objResult->dscPerfil = $row->dscperfil;

                    $return = 0;
                    $message = MSG_OK_GENERAL;
                }
                else
                {
                    $return = 1;
                    $message = "Password Incorrecto";
                }
            }
            else
            {
                $return = 1;
                $message = "Usuario no Existe";
            }
        }
        else
        {
            $return = 1;
            $message = MSG_ERROR_GENERAL;
        }

        return $objResult;
    }    
}
?>    